<?php


//define('WP_USE_THEMES', false);
//require('./../../../wp-blog-header.php');

error_reporting(E_ALL & ~E_DEPRECATED & ~E_WARNING);
ini_set('display_errors', 0);

define( 'CD_PLUGIN_PATH', plugin_dir_path( __FILE__ ) );


//require CD_PLUGIN_PATH.'vendor/autoload.php';
//require CD_PLUGIN_PATH.'vendor/dompdf/autoload.inc.php';
//require CD_PLUGIN_PATH.'vendor/tc-lib-unicode-main/autoload.php';



// use Dompdf\Dompdf;
// use Dompdf\Options;

//printPDF(1);


function printPDF($order_id='') {

    if (current_user_can('administrator') || current_user_can('editor')) {

    } else {
        echo ('no permission');
        return;
    }

    //$order_id = $_GET['id']; 
    
    $orders = explode(",",$order_id);
    foreach($orders as $order_id) {
    
        $order = wc_get_order( $order_id );

        if (!is_object($order)) {
            //var_dump('not an order',$order);
            //var_dump('continue on order'.$order_id);
            continue;
        }


        $barcode                = '';
        $origin_fullname        = '';
        $origin_phone           = '';
        $origin_address         = '';
        $destination_fullname   = $order->get_shipping_first_name() . ' ' . $order->get_shipping_last_name();
        $destination_address    = $order->get_shipping_address_1() .','.$order->get_shipping_address_2();
        $destination_city       = $order->get_shipping_city();
        $destination_phone      = str_replace(array("-"," "),array("",""),$order->get_shipping_phone());
        $contract_name          = '';
        $contact_number         = '';
        $ncode                  = '';
        $notes                  = '';
        $datalogics_platform_id = '';
        $ncode_name = '';
        $delivery_logo = '';
        $custom_logo = '';
        $line = '';
        $area = '';
        $shipment_type = '';
        


        $datalogics_platform_id = get_post_meta( $order_id, 'datalogics_platform_id', true);
        $datalogics_shipping    = get_post_meta( $order_id, 'datalogics_shipping', true);
        if ($datalogics_shipping!='') {
            $meta_data = json_decode($datalogics_shipping);
            //var_dump( $meta_data);
            $barcode = $meta_data->tracking_number;
            $line    = $meta_data->line_number;
            $area    = $meta_data->area;
        }

        $destination_fullname = get_post_meta( $order_id, 'datalogics_fullname', true);
        $destination_address  = get_post_meta( $order_id, 'datalogics_address', true);
        $destination_address  .= ' ' . get_post_meta( $order_id, 'datalogics_house', true);

        $destination_city = get_post_meta( $order_id, 'datalogics_city', true);

        $destination_phone = get_post_meta( $order_id, 'datalogics_phone', true);
        $destination_phone = str_replace(array("-"," "),array("",""),$destination_phone);

        $ncode = get_post_meta( $order_id, 'datalogics_n_code', true);

        $shipment_type = get_post_meta( $order_id, 'datalogics_shipment_type', true);



        // foreach ($order->meta_data as $meta) {
        //     //var_dump($meta);

        //     if ($meta->key=='datalogics_platform_id') {
        //         $datalogics_platform_id = $meta->value;
        //     }

        //     if ($meta->key=='datalogics_shipping') {
        //         $meta_data = json_decode($meta->value);
        //         //var_dump( $meta_data);
        //         $barcode = $meta_data->tracking_number;
        //         $line    = $meta_data->line_number;
        //         $area    = $meta_data->area;
        //     }

        //     if ($meta->key=='datalogics_fullname') {
        //         $destination_fullname = $meta->value;
        //     }

        //     if ($meta->key=='datalogics_address') {
        //         $destination_address = $meta->value;
        //     }
        //     if ($meta->key=='datalogics_house') {
        //         $destination_address .= ' '.$meta->value;
        //     }
        //     if ($meta->key=='datalogics_city') {
        //         $destination_city = $meta->value;
        //     }

        //     if ($meta->key=='datalogics_phone') {
        //         $destination_phone = str_replace(array("-"," "),array("",""),$meta->value);
        //     }

        //     if ($meta->key=='datalogics_n_code') {
        //         $ncode = $meta->value;
        //     }     
            
        //     if ($meta->key=='datalogics_shipment_type'){
        //         $shipment_type = $meta->value;
        //     }
        // }

        if ($barcode=='') {
            //var_dump(' no barcode ' ,$order->get_id(), $order->meta_data , $order->get_meta());
            continue;
        }

        if ($ncode!='') {
            
            //$ncode_list = unserialize(get_option('datalogics_shipping_locations'));
            $ncode_list = get_option('datalogics_shipping_locations');
            if ($ncode_list!='' && !is_array($ncode_list)) {
                $ncode_list = unserialize($ncode_list);
            }
            
            if (isset($ncode_list[$datalogics_platform_id])) {                                                        
                foreach ($ncode_list[$datalogics_platform_id] as $values){                
                    foreach ($values as $value){
                        if ($value['n_code']==$ncode) {

                            if (in_array($datalogics_platform_id,[61,62,63])) {

                                //$destination_fullname = 'נקודת מסירה' . ' (' . $ncode .') ' . $value['name'];
                                $destination_address = $value['street'] . ' ' . $value['house'];
                                $destination_city    = $value['city'];

                            }

                            $ncode_name = $value['name'] . ' - ' . $value['city'] . ',' . $value['street'];

                            
                        }
                    }
                }
            }
        }


        
        $custom_logo = get_option('datalogics_print_logo','');
        $delivery_logo = CD_PLUGIN_PATH.'images/logos/'.$datalogics_platform_id.'.jpg';
        if (!file_exists($delivery_logo)) {
            $delivery_logo = CD_PLUGIN_PATH.'images/logos/'.$datalogics_platform_id.'.png';
            if (!file_exists($delivery_logo)) {
                $delivery_logo = CD_PLUGIN_PATH.'images/logos/'.$datalogics_platform_id.'.svg';
                if (!file_exists($delivery_logo)) {
                    $delivery_logo = '';
                }
            }
        }

        

        if (in_array($datalogics_platform_id,[61,62,63])) {
            if ($ncode!='') {
                $delivery_logo = CD_PLUGIN_PATH.'images/logos/click2post_min.jpg';        
            } else {        
                $delivery_logo = CD_PLUGIN_PATH.'images/logos/postil.jpg';
            }
        }


        $datalogics_inventory_location = get_post_meta($order_id, 'datalogics_location',true);
        $datalogics_shipping = get_post_meta( $order_id, 'datalogics_shipping', true);
                
        if ($datalogics_shipping=='') {

            $datalogics_shipping = [];

        } else {            

            if (!is_array($datalogics_shipping)) {

                $datalogics_shipping = json_decode($datalogics_shipping,true);

            }

        }

        $shipment = $datalogics_shipping;


        $datalogics_shipping_method = get_option('datalogics_shipping_method',''); 
        if ($datalogics_shipping_method!='') {
            if (is_string($datalogics_shipping_method)) {  
                $datalogics_shipping_method = json_decode($datalogics_shipping_method,true);  
            }
        }
        



        $companies = get_option('datalogics_shipping_companies');
        if ($companies=='') {                        
            $companies = [];
        } else if (is_string($companies)) {          

            $companies = json_decode($companies,true);                    
        }



        foreach($companies as $platform_id=>$company_item) {
            if ($platform_id==$shipment['platform_id']) {
                //$datalogics_platform_id;
                foreach($datalogics_shipping_method as $method) {

                    //var_dump($method['shipping_push_supplier'],$shipment['platform_id']);

                    if ($method['shipping_push_supplier']==$shipment['platform_id']) {

                        if (isset($method['shipping_push_supplier_code'])) {

                            $contract_number = $method['shipping_push_supplier_code'];

                            // if ($ncode!='') {

                            //     $contract_number = $method['shipping_push_supplier_code_pickup'];
        
                            // }

                        }

                        if (isset($method['shipping_push_supplier_contract'])) {

                            $contract_number = $method['shipping_push_supplier_contract'];

                            // if ($ncode!='') {

                            //     $contract_number = $method['shipping_push_supplier_pudo_contract'];
        
                            // }

                        }                    


                    }
                }
            }
        }

        $products_in_comments = get_option('shipping_push_products_in_comments','');
        $items = [];             
        foreach( $order->get_items() as $item_id => $item )
        {

            $product = $item->get_product();
            $sku = $product->get_sku();                    
            $item_data = $item->get_data();                    
            $items[] = $item_data['quantity'] .' x ( ' .$sku .' ) ' . $item_data['name']; 
                        
        }





        $inventory_locations = get_option('datalogics_update_inventory_locations',''); 
        if ($inventory_locations!='') {
            if (is_string($inventory_locations)) {  
                $inventory_locations = json_decode($inventory_locations,true);  
            }

            $location = end($inventory_locations);
            $origin_fullname = $location['label'];
            $origin_address = $location['street'] . ' '.$location['house'] .', ' .$location['city'];
            $origin_phone   = str_replace(array("-"," "),array("",""),$location['phone']);

        }


        ob_start();
        if (in_array($datalogics_platform_id,[61,62,63])) {
            include 'prints/pattern1.php';
        } else {
            $pattern = get_option('datalogics_print_pattern',''); 
            include 'prints/pattern'.(($pattern!='') ? $pattern : 1) .'.php';
        }
        $html = ob_get_clean();


        echo $html;

    }

    die;


    /*

    // instantiate and use the dompdf class
    $options = new Options();
    $options->set('isHtml5ParserEnabled', true);
    //$options->set('isPhpEnabled', true);
    $options->set('defaultCharset', 'utf-8');
    //$options->set('isFontSubsettingEnabled', true);
    // $options->set('debug', true);
    $options->set('isRemoteEnabled',true);
    //$options->set('defaultFont', 'Times');

    $dompdf = new Dompdf($options);
    $dompdf->loadHtml($html);

    // (Optional) Setup the paper size and orientation
    $dompdf->setPaper('A4');

    // Render the HTML as PDF
    $dompdf->render();

    // Output the generated PDF to Browser
    //$dompdf->output();

    $pdfFilePath = 'example.pdf';

    file_put_contents($pdfFilePath, $dompdf->output());

    $dompdf->stream('example.pdf', [
        'compress' => true,
        'Attachment' => false,
    ]);

    */

    

    // header('Content-Type: application/pdf');
    // header('Content-Disposition: inline; filename="'.$pdfFilePath.'"'); 
    // header('Content-Length: ' . filesize($pdfFilePath)); 
    
    // $fileHandle = fopen($pdfFilePath, 'rb');
    // if ($fileHandle === false) {
    //     // Handle the case where the file cannot be opened
    //     echo 'Failed to open the PDF file.';
    // } else {
    //     // Output the file content
    //     while (!feof($fileHandle)) {
    //         echo fread($fileHandle, 8192); // Read and output in chunks
    //     }

    //     // Close the file handle
    //     fclose($fileHandle);
    // }

    //readfile($pdfFilePath);


    //$dompdf->stream('example.pdf');



    //die;

    // $output = $dompdf->output();

    // $filename = $CardID.'-'.$PinNumber.'.pdf';

    // $file = CD_PLUGIN_PATH.$filename;

    // file_put_contents($file, $output);
    

}


function datalogics_convert_base64($path) {



    $type = pathinfo($path, PATHINFO_EXTENSION);
    $data = file_get_contents($path);
    //echo base64_encode($data);
    $base64 = 'data:image/' . $type . ';base64,' . base64_encode($data);
    return $base64;

}


function mb_strrev($str, $encoding = 'UTF-8') {
    $length = mb_strlen($str, $encoding);
    $reversed = '';
    
    while ($length > 0) {
        $char = mb_substr($str, $length - 1, 1, $encoding);
        $reversed .= $char;
        $length--;
    }
    
    return $reversed;
}
