<?php

//Global variables
global $settings;
function datalogics_settings_return(){
    $settings = array();
    $settings['shipping_pull_platform']             = 4; // wordpress
    
    $settings['datalogics_google_key']              = get_option('datalogics_google_key', '');
    $settings['shipping_push_products_in_comments'] = get_option('shipping_push_products_in_comments', '');
    $settings['shipping_push_notes_in_comments']    = get_option('shipping_push_notes_in_comments', '');
    $settings['shipping_pull_website']              = get_site_url();

    $settings['datalogics_cities_list']             = get_option('datalogics_cities_list', '');
    $settings['datalogics_cities_auto']             = get_option('datalogics_cities_auto', '');
    $settings['datalogics_cities_auto_validation']  = get_option('datalogics_cities_auto_validation', '');
    $settings['datalogics_ncode_auto']              = get_option('datalogics_ncode_auto', '');
    $settings['datalogics_shipping_options_enabled']= get_option('datalogics_shipping_options_enabled','');
    $settings['datalogics_myaccount_tracking']      = get_option('datalogics_myaccount_tracking','');
    $settings['datalogics_myaccount_tracking_email']      = get_option('datalogics_myaccount_tracking_email','');
    $settings['datalogics_myaccount_tracking_email_link']      = get_option('datalogics_myaccount_tracking_email_link','');
    $settings['order_statuses_limit']               = get_option('order_statuses_limit','');
    $settings['datalogics_view_option']             = get_option('datalogics_view_option','');
    $settings['datalogics_print_logo']              = get_option('datalogics_print_logo','');
    $settings['datalogics_print_pattern']              = get_option('datalogics_print_pattern','');
    
    $settings['datalogics_custom_label']            = get_option('datalogics_custom_label','');
    

    $settings['shipping_pull_api_key_custom']              = get_option('datalogics_api_key', '');
    $settings['shipping_pull_api_password_custom']         = get_option('datalogics_api_secret', '');

    $settings['user_id']                            = get_current_user_id();
    $settings['datalogics_firstname']               = get_option('datalogics_firstname', '');
    $settings['datalogics_lastname']                = get_option('datalogics_lastname', '');
    $settings['datalogics_company']                 = get_option('datalogics_company', '');
    $settings['datalogics_email']                   = get_option('datalogics_email', '');
    $settings['datalogics_phone']                   = get_option('datalogics_phone', '');
    $settings['datalogics_billing_map_street']      = get_option('datalogics_billing_map_street', '');
    $settings['datalogics_billing_map_house']       = get_option('datalogics_billing_map_house', '');
    $settings['datalogics_billing_map_apartment']   = get_option('datalogics_billing_map_apartment', '');
    $settings['datalogics_billing_map_entrance']    = get_option('datalogics_billing_map_entrance', '');
    $settings['datalogics_billing_map_floor']       = get_option('datalogics_billing_map_floor', '');
    $settings['datalogics_billing_map_door']        = get_option('datalogics_billing_map_door', '');
    $settings['datalogics_shipping_map_street']     = get_option('datalogics_shipping_map_street', '');
    $settings['datalogics_shipping_map_house']      = get_option('datalogics_shipping_map_house', '');
    $settings['datalogics_shipping_map_apartment']  = get_option('datalogics_shipping_map_apartment', '');
    $settings['datalogics_shipping_map_entrance']   = get_option('datalogics_shipping_map_entrance', '');
    $settings['datalogics_shipping_map_floor']      = get_option('datalogics_shipping_map_floor', '');
    $settings['datalogics_shipping_map_door']       = get_option('datalogics_shipping_map_door', '');

    $settings['datalogics_update_inventory_locations'] = get_option('datalogics_update_inventory_locations', '');
    if ($settings['datalogics_update_inventory_locations']!='') {
        $settings['datalogics_update_inventory_locations'] = json_decode($settings['datalogics_update_inventory_locations']);
    }
    $settings['shipping_method']                       = get_option('datalogics_shipping_method','');
    if ($settings['shipping_method']!='') {
        $settings['shipping_method'] = json_decode($settings['shipping_method']);
    }

    
    return $settings;
}

//Settings page submit
add_action( 'admin_post_nopriv_datalogics_settings_save', 'datalogics_settings_save');
add_action( 'admin_post_datalogics_settings_save', 'datalogics_settings_save' );
add_action( 'wp_ajax_datalogics_settings_save', 'datalogics_settings_save' );

function datalogics_settings_save()
{

    datalogics_create_api();

    foreach($_POST as $key=>$value) {
        if ($_POST[$key]=='false') {
            $_POST[$key] = '';
        }
        if ($_POST[$key]=='true') {
            $_POST[$key] = 1;
        }
    }

    //$shipping_pull_platform                 = $_POST['shipping_pull_platform'];
    $shipping_push_supplier_code            = $_POST['shipping_push_supplier_code'];
    $shipping_push_supplier_code_pickup     = $_POST['shipping_push_supplier_code_pickup'];
    $shipping_push_supplier_name            = $_POST['shipping_push_supplier_name'];
    $shipping_push_supplier_city            = $_POST['shipping_push_supplier_city'];
    $shipping_push_supplier_street          = $_POST['shipping_push_supplier_street'];
    $shipping_push_supplier_house           = $_POST['shipping_push_supplier_house'];
    

    
    $shipping_push_products_in_comments     = (isset($_POST['shipping_push_products_in_comments'])) ? $_POST['shipping_push_products_in_comments'] : '';
    $shipping_push_notes_in_comments        = (isset($_POST['shipping_push_notes_in_comments'])) ? $_POST['shipping_push_notes_in_comments'] : '';
    $datalogics_cities_list                 = (isset($_POST['datalogics_cities_list'])) ? $_POST['datalogics_cities_list'] : '';
    $datalogics_cities_auto                 = (isset($_POST['datalogics_cities_auto'])) ? $_POST['datalogics_cities_auto'] : '';
    $datalogics_cities_auto_validation      = (isset($_POST['datalogics_cities_auto_validation'])) ? $_POST['datalogics_cities_auto_validation'] : '';    
    
    $datalogics_ncode_auto                  = (isset($_POST['datalogics_ncode_auto'])) ? $_POST['datalogics_ncode_auto'] : '';
    $datalogics_skip_jquery                 = (isset($_POST['datalogics_skip_jquery'])) ? $_POST['datalogics_skip_jquery'] : '';
    $datalogics_shipping_options_enabled    = (isset($_POST['datalogics_shipping_options_enabled'])) ? $_POST['datalogics_shipping_options_enabled'] : '';
    $datalogics_myaccount_tracking          = (isset($_POST['datalogics_myaccount_tracking'])) ? $_POST['datalogics_myaccount_tracking'] : '';
    $datalogics_myaccount_tracking_email    = (isset($_POST['datalogics_myaccount_tracking_email'])) ? $_POST['datalogics_myaccount_tracking_email'] : '';
    $datalogics_google_key                  = trim($_POST['datalogics_google_key']);
    $shipping_push_supplier                 = $_POST['shipping_push_supplier'];
    $shipping_order_status                  = $_POST['order_statuses'];
    $order_statuses_limit                   = $_POST['order_statuses_limit'];
    $datalogics_view_option                 = $_POST['datalogics_view_option'];
    if ($datalogics_google_key=='') {
        $datalogics_view_option = 2; 
    }
    $datalogics_print_logo                  = $_POST['datalogics_print_logo'];
    $datalogics_print_pattern                  = $_POST['datalogics_print_pattern'];
    
    $datalogics_custom_label                = (isset($_POST['datalogics_custom_label'])) ? $_POST['datalogics_custom_label'] : '';


    $datalogics_myaccount_tracking_email_link = $_POST['datalogics_myaccount_tracking_email_link'];



       
    
    $datalogics_shipping_options            = $_POST['datalogics_shipping_options'];
    if ($datalogics_shipping_options!=''){
        $datalogics_shipping_options = json_encode($datalogics_shipping_options);
    } else {
        $datalogics_shipping_options = '';
    }


    $datalogics_token                   = $_POST['datalogics_token'];
    $datalogics_location_select         = $_POST['datalogics_location_select'];
    $datalogics_billing_map_street      = $_POST['datalogics_billing_map_street'];
    $datalogics_billing_map_house       = $_POST['datalogics_billing_map_house'];
    $datalogics_billing_map_apartment   = $_POST['datalogics_billing_map_apartment'];
    $datalogics_billing_map_entrance    = $_POST['datalogics_billing_map_entrance'];
    $datalogics_billing_map_floor       = $_POST['datalogics_billing_map_floor'];
    $datalogics_billing_map_door        = $_POST['datalogics_billing_map_door'];

    $datalogics_shipping_map_street      = $_POST['datalogics_shipping_map_street'];
    $datalogics_shipping_map_house       = $_POST['datalogics_shipping_map_house'];
    $datalogics_shipping_map_apartment   = $_POST['datalogics_shipping_map_apartment'];
    $datalogics_shipping_map_entrance    = $_POST['datalogics_shipping_map_entrance'];
    $datalogics_shipping_map_floor       = $_POST['datalogics_shipping_map_floor'];
    $datalogics_shipping_map_door        = $_POST['datalogics_shipping_map_door'];


    



    update_option('datalogics_version', '2');


    update_option('datalogics_token', $datalogics_token);

    //var_dump($datalogics_shipping_options);

    update_option('shipping_push_supplier_code', $shipping_push_supplier_code);
    update_option('shipping_push_supplier_code_pickup', $shipping_push_supplier_code_pickup);
    update_option('shipping_push_supplier_name', $shipping_push_supplier_name);
    update_option('shipping_push_supplier_city', $shipping_push_supplier_city);
    update_option('shipping_push_supplier_street', $shipping_push_supplier_street);
    update_option('shipping_push_supplier_house', $shipping_push_supplier_house);
    update_option('shipping_push_products_in_comments', $shipping_push_products_in_comments);
    update_option('shipping_push_notes_in_comments', $shipping_push_notes_in_comments);
    update_option('datalogics_myaccount_tracking', $datalogics_myaccount_tracking);
    update_option('datalogics_myaccount_tracking_email', $datalogics_myaccount_tracking_email);
    update_option('datalogics_google_key', $datalogics_google_key);
    update_option('datalogics_myaccount_tracking_email_link', $datalogics_myaccount_tracking_email_link);
    update_option('order_statuses_limit', $order_statuses_limit);
    update_option('datalogics_view_option', $datalogics_view_option);
    update_option('datalogics_print_logo',$datalogics_print_logo);
    update_option('datalogics_print_pattern',$datalogics_print_pattern);
    
    update_option('datalogics_custom_label',$datalogics_custom_label);    
    update_option('datalogics_billing_map_street',$datalogics_billing_map_street);
    update_option('datalogics_billing_map_house',$datalogics_billing_map_house);
    update_option('datalogics_billing_map_apartment',$datalogics_billing_map_apartment);
    update_option('datalogics_billing_map_entrance',$datalogics_billing_map_entrance);
    update_option('datalogics_billing_map_floor',$datalogics_billing_map_floor);
    update_option('datalogics_billing_map_door',$datalogics_billing_map_door);
    update_option('datalogics_shipping_map_street',$datalogics_shipping_map_street);
    update_option('datalogics_shipping_map_house',$datalogics_shipping_map_house);
    update_option('datalogics_shipping_map_apartment',$datalogics_shipping_map_apartment);
    update_option('datalogics_shipping_map_entrance',$datalogics_shipping_map_entrance);
    update_option('datalogics_shipping_map_floor',$datalogics_shipping_map_floor);
    update_option('datalogics_shipping_map_door',$datalogics_shipping_map_door);

    
    




    update_option('datalogics_cities_list', $datalogics_cities_list);
    update_option('datalogics_cities_auto', $datalogics_cities_auto);
    update_option('datalogics_cities_auto_validation', $datalogics_cities_auto_validation);
    update_option('datalogics_ncode_auto', $datalogics_ncode_auto);
    
    update_option('shipping_push_supplier', $shipping_push_supplier);
    update_option('shipping_order_status', $shipping_order_status);
    update_option('datalogics_shipping_options', $datalogics_shipping_options);
    
    

    update_option('datalogics_location_select', $datalogics_location_select);
    update_option('datalogics_skip_jquery', $datalogics_skip_jquery);
    update_option('datalogics_shipping_options_enabled',$datalogics_shipping_options_enabled);



    //var_dump($shipping_company);

    datalogics_update_locations();
    get_datalogics_shipping_companies();
    wp_send_json(['success'=>1]);

    //wp_redirect( $_SERVER["HTTP_REFERER"] . '&success=true', 302, 'WordPress' );
}

//Order page submit
// Save the data of the Meta field
add_action( 'save_post', 'mv_save_wc_order_other_fields', 10, 1 );
if ( ! function_exists( 'mv_save_wc_order_other_fields' ) )
{

    function mv_save_wc_order_other_fields( $post_id ) {

        // We need to verify this with the proper authorization (security stuff).

        // Check if our nonce is set.
        if ( ! isset( $_POST[ 'dln' ] ) ) {
            return $post_id;
        }
        $nonce = $_REQUEST[ 'dln' ];

        //Verify that the nonce is valid.
        if ( ! wp_verify_nonce( $nonce ) ) {
            return $post_id;
        }

        // If this is an autosave, our form has not been submitted, so we don't want to do anything.
        if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) {
            return $post_id;
        }

        // Check the user's permissions.
        if ( 'page' == $_POST[ 'post_type' ] ) {

            if ( ! current_user_can( 'edit_page', $post_id ) ) {
                return $post_id;
            }
        } else {

            if ( ! current_user_can( 'edit_post', $post_id ) ) {
                return $post_id;
            }
        }
        // --- Its safe for us to save the data ! --- //

        // Sanitize user input  and update the meta field in the database.
        if(isset($_POST[ 'datalogics_govina' ])) {
            update_post_meta($post_id, 'datalogics_govina', $_POST['datalogics_govina']);
        }

        if(isset($_POST[ 'datalogics_govina_sum' ])) {
            update_post_meta($post_id, 'datalogics_govina_sum', $_POST['datalogics_govina_sum']);
        }


        if(isset($_POST[ 'datalogics_shipping' ]) && $_POST[ 'datalogics_shipping' ] != '') {
            update_post_meta($post_id, 'datalogics_shipping', $_POST['datalogics_shipping']);
        }
        if(isset($_POST[ 'datalogics_comment' ]) && $_POST[ 'datalogics_comment' ] != '') {
            update_post_meta($post_id, 'datalogics_comment', $_POST['datalogics_comment']);
        }


    }
}







//AJAX Cancel shipping
add_action( 'wp_ajax_datalogics_cancel', 'datalogics_cancel' );

function datalogics_cancel() {

    update_post_meta( $_POST['post_id'], 'datalogics_shipping', '' );
    update_post_meta( $_POST['post_id'], 'datalogics_shipping_line','');
    update_post_meta( $_POST['post_id'], 'datalogics_govina', $_POST[ 'datalogics_govina' ] );
    update_post_meta( $_POST['post_id'], 'datalogics_govina_sum', $_POST[ 'datalogics_govina_sum' ] );
    update_post_meta( $_POST['post_id'], 'datalogics_comment', $_POST[ 'datalogics_comment' ] );

    echo true;

    wp_die(); // this is required to terminate immediately and return a proper response
}

//AJAX Submit shipping
add_action( 'wp_ajax_datalogics_submit', 'datalogics_submit' );

function datalogics_submit() {

    update_post_meta( $_POST['post_id'], 'datalogics_govina', $_POST[ 'datalogics_govina' ] );
    update_post_meta( $_POST['post_id'], 'datalogics_govina_sum', $_POST[ 'datalogics_govina_sum' ] );
    update_post_meta( $_POST['post_id'], 'datalogics_comment', $_POST[ 'datalogics_comment' ] );
    update_post_meta( $_POST['post_id'], 'datalogics_shipping', $_POST[ 'datalogics_shipping' ] );
    //update_option('datalogics_api_key', $_POST['datalogics_api_key']);
    //update_option('datalogics_api_secret', $_POST['datalogics_api_secret']);

    echo true;

    wp_die(); // this is required to terminate immediately and return a proper response
}

//AJAX Get Locations on checkout
add_action( 'wp_ajax_datalogics_get_locations', 'datalogics_get_locations' );
add_action( 'wp_ajax_nopriv_datalogics_get_locations', 'datalogics_get_locations' );

function datalogics_get_locations() {
    //$city = $_POST['city'];
    // $locations = unserialize(get_option('datalogics_shipping_locations'));
    $locations = get_option('datalogics_shipping_locations');
    if ($locations!='' && !is_array($locations)) {
        $locations = unserialize($locations);
    }
    $existing_companies = get_option('datalogics_shipping_method', '');
    $existing_companies = json_decode($existing_companies,true); 


    foreach ($locations as $platform_id => $values){

        $company_exist_check = false;
    
        foreach($existing_companies as $exist_company) {

            if ($exist_company['shipping_push_supplier']==$platform_id) {

                $company_exist_check = true;

            }

        }

        if ($company_exist_check == false) {
            unset($locations[$platform_id]);
        }


        

    }


    //wp_send_json($locations[$city]);
    wp_send_json($locations);
}




add_action( 'wp_ajax_datalogics_update_inventory_locations', 'datalogics_update_inventory_locations' );
function datalogics_update_inventory_locations() {

    

    $exist_datalogics_update_inventory_locations = get_option('datalogics_update_inventory_locations', '');
    if ($exist_datalogics_update_inventory_locations!='') {
        $exist_datalogics_update_inventory_locations = json_decode($exist_datalogics_update_inventory_locations,true);
    } else {
        $exist_datalogics_update_inventory_locations = [];
    }

    $datalogics_update_inventory_locations = $_POST['datalogics_update_inventory_locations'];    
    
    foreach($datalogics_update_inventory_locations as $method_key=>$method) {

        foreach($exist_datalogics_update_inventory_locations as $method2) {

            if ($method['id']==$method2['id']) {

                foreach($method2 as $key2=>$value2) {

                    if (!isset($datalogics_update_inventory_locations[$method_key][$key2])) {

                        $datalogics_update_inventory_locations[$method_key][$key2] = $value2;

                    }

                }

            }
        }
    }

    if ($datalogics_update_inventory_locations=='') {
        $datalogics_update_inventory_locations = [];
    }

    $datalogics_update_inventory_locations = json_encode($datalogics_update_inventory_locations);

    update_option('datalogics_update_inventory_locations', $datalogics_update_inventory_locations);

    wp_send_json(['success'=>1]);
    die;

}


add_action( 'wp_ajax_datalogics_update_companies', 'datalogics_update_companies' );
function datalogics_update_companies() {

    $exist_datalogics_shipping_method = get_option('datalogics_shipping_method', '');
    if ($exist_datalogics_shipping_method!='') {
        $exist_datalogics_shipping_method = json_decode($exist_datalogics_shipping_method,true);
    } else {
        $exist_datalogics_shipping_method = [];
    }

    $datalogics_shipping_method = $_POST['datalogics_shipping_method'];    
    
    foreach($datalogics_shipping_method as $method_key=>$method) {

        foreach($exist_datalogics_shipping_method as $method2) {

            if ($method['shipping_push_supplier']==$method2['shipping_push_supplier']) {

                foreach($method2 as $key2=>$value2) {

                    if (!isset($datalogics_shipping_method[$method_key][$key2])) {

                        $datalogics_shipping_method[$method_key][$key2] = $value2;

                    }

                }

            }
        }
    }

    if ($datalogics_shipping_method=='') {
        $datalogics_shipping_method = [];
    }


    if (DATALOGICS_COMPANY=='POSTIL') {

        foreach($datalogics_shipping_method as $method_key=>$method2) {
            if (!in_array($method2['shipping_push_supplier'],[61,62,63])) {
                unset($datalogics_shipping_method[$method_key]);
            }       
            
        }
    }

    datalogics_update_shipping_method($datalogics_shipping_method);
    datalogics_update_locations();

    $datalogics_shipping_method = json_encode($datalogics_shipping_method);

    update_option('datalogics_shipping_method', $datalogics_shipping_method);

    wp_send_json(['success'=>1]);
    die;


}



function datalogics_update_shipping_method($datalogics_shipping_method) {
    



    $url = 'https://connect.datalogics.co.il/rest/w_update_shipping_methods';

    $data = [
        'datalogics_shipping_method'=>$datalogics_shipping_method,
    ];

    $data['token']   = get_option('datalogics_token', '');

    $result = wp_remote_post($url,
        array(
            "headers" => [
                'Content-Type' => 'text/xml',
            ],
            "body" => json_encode($data),
            "sslverify" => false,
        )
    );
    if(!is_wp_error($result)){


        //var_dump($result);

        
    }

}


add_action( 'wp_ajax_datalogics_register', 'datalogics_register' );
function datalogics_register() {
    



    $responseObject['success'] = 0;   

    $url = 'https://connect.datalogics.co.il/rest/w_register';

    $data = [
        'firstname'=>$_POST['datalogics_firstname'],
        'lastname'=>$_POST['datalogics_lastname'],
        'company'=>$_POST['datalogics_company'],
        'vat'=>$_POST['datalogics_vat_number'],
        'email'=>$_POST['datalogics_email'],
        'phone'=>$_POST['datalogics_phone'],
    ];

    if (DATALOGICS_COMPANY=='POSTIL') {

        $data['postil'] = 1;
    }

    update_option('datalogics_firstname',$_POST['datalogics_firstname']);
    update_option('datalogics_lastname',$_POST['datalogics_lastname']);
    update_option('datalogics_company',$_POST['datalogics_company']);
    update_option('datalogics_vat_number',$_POST['datalogics_vat_number']);
    update_option('datalogics_email',$_POST['datalogics_email']);
    update_option('datalogics_phone',$_POST['datalogics_phone']);


    $result = wp_remote_post($url,
        array(
            "headers" => [
                'Content-Type' => 'text/xml',
            ],
            "body" => json_encode($data),
            "sslverify" => false,
        )
    );
    if(!is_wp_error($result)){

        $response = json_decode($result['http_response']->get_response_object()->body);

        //var_dump($response);

        if($response->success){

            $responseObject['success'] = 1;
            $responseObject['token'] = $response->token;

            update_option('datalogics_token',$response->token);


            
        } else {

            $responseObject['msg'] = __( 'Please contact plugin support', 'datalogics_shipping' );

        }


    }

    

    wp_send_json($responseObject);
    die;

}

add_action( 'wp_ajax_datalogics_validate_key', 'datalogics_validate_key' );
function datalogics_validate_key() {

    $token = $_POST['token'];

    update_option('datalogics_token',$token);

    $responseObject['success'] = 0;

    if ($token!='') {     

        $url = 'https://connect.datalogics.co.il/rest/w_validate_key';

        $data = [];
        $data['token']   = $token;
        if($data['token'] != ''){
            $result = wp_remote_post($url,
                array(
                    "headers" => [
                        'Content-Type' => 'text/xml',
                    ],
                    "body" => json_encode($data),
                    "sslverify" => false,
                )
            );
            if(!is_wp_error($result)){

                $response = json_decode($result['http_response']->get_response_object()->body);

                //var_dump($response);

                if (isset($response->payment_link)) {
                    $responseObject['payment_link'] = $response->payment_link;
                }

                if($response->success){

                    $responseObject['success'] = 1;
                    if (isset($response->products)) {
                        $responseObject['products'] = $response->products;
                    }                   

                    

                    $datalogics_shipping_method = get_option('datalogics_shipping_method','');

                    if ($datalogics_shipping_method=='' && $response->datalogics_shipping_method!='') {
                    
                        update_option('datalogics_shipping_method',$response->datalogics_shipping_method);

                    }
                    
                }


            }
        }
    }

    wp_send_json($responseObject);
    die;

}



//Running Cron to get locations

function datalogics_update_locations() {

    $datalogics_shipping_method_string = get_option('datalogics_shipping_method','');

    if ($datalogics_shipping_method_string=='') {
        return;
    }         
    $datalogics_shipping_method = json_decode($datalogics_shipping_method_string);

    $url = 'https://connect.datalogics.co.il/rest/w_get_shipping_stores';

    $data = [];
    $data['token']   = get_option('datalogics_token', '');
    $data['settings'] = array('shipping_method' => $datalogics_shipping_method);
    $data['version'] = 2;
    if($data['token'] != ''){
        $result = wp_remote_post($url,
            array(
                    "headers" => [
                        'Content-Type' => 'text/xml',
                    ],
                    "body" => json_encode($data),
                    "sslverify" => false,
            )
        );
        if(!is_wp_error($result)){


            $response = json_decode($result['http_response']->get_response_object()->body);

            //var_dump($response);

            if($response->success){
                $data = $response->data;
                if($response->success != 0){
                    $locations = array();
                    foreach ($data as $platform_id=>$store_by_platform) {

                        $platform_passed = false;

                        foreach($datalogics_shipping_method as $esy) {


                            if (isset($esy->shipping_push_supplier) &&                                 
                                $esy->shipping_push_supplier==$platform_id) 
                            {
                            

                            // if (isset($esy->shipping_push_supplier) && 
                            //     isset($esy->shipping_push_supplier_code_pickup) && 
                            //     $esy->shipping_push_supplier==$platform_id && 
                            //     $esy->shipping_push_supplier_code_pickup!='') 
                            // {

                                //var_dump( $esy->shipping_push_supplier . '=====' . $platform_id );

                                $platform_passed = true;

                            }

                        }

                        if ( $platform_passed==false) {
                            continue;
                        }

                        

                        if (!isset($locations[$platform_id]))
                        {
                            $locations[$platform_id] = [];
                        }

                        foreach($store_by_platform as $city_name=>$city_data) {

                            $json  = json_encode($city_data);

                            $array = json_decode($json, true);

                            $locations[$platform_id][$city_name] = $array;

                        }

                    }
                    //var_dump($locations);
                    if (!empty($locations)) {
                        $locations = serialize($locations);
                        update_option('datalogics_shipping_locations', $locations);
                    }
                }
            }


        }
    }


    // $response = file_get_contents('https://connect.datalogics.co.il/rest/w_get_shipping_stores');
    // //var_dump($response);
    // $response = json_decode($response);
    // if($response->success){
    //     $data = $response->data;
    //     if($response->success != 0){
    //         $locations = array();
    //         foreach ($data as $platform_id=>$store_by_platform) {

    //             if (!isset($location[$platform_id]))
    //             {
    //                 $location[$platform_id] = [];
    //             }

    //             foreach($store_by_platform as $city_name=>$city_data) {

    //                 $json  = json_encode($city_data);

    //                 $array = json_decode($json, true);

    //                 $location[$platform_id][$city_name] = $array;

    //             }

    //         }
    //         $locations = serialize($locations);
    //         update_option('datalogics_shipping_locations', $locations);
    //     }
    // }
}

//Action to send shipping on order status change
add_action('woocommerce_order_status_changed', 'datalogics_order_status_change', 10, 3);
function datalogics_order_status_change($order_id,$old_status,$new_status) {

    $shipping_method = datalogics_check_allowed_shipping($order_id);

    if ($shipping_method == false) {
        return;
    }


    $datalogics_order_status = get_option('shipping_order_status', '');


    $new_status_temp                = str_replace("wc-","",$new_status);
    $datalogics_order_status_temp   = str_replace("wc-","",$datalogics_order_status);

    if($new_status_temp == $datalogics_order_status_temp){
        datalogics_create_shipping($order_id);
    }
}


// Adding to admin order list bulk dropdown a custom action 'custom_downloads'
// add_filter( 'bulk_actions-edit-shop_order', 'datalogics_bulk_action', 20, 1 );
// function datalogics_bulk_action( $actions ) {
//     $actions['datalogics_bulk_send_shipping'] = __( 'Datalogics Send Shipping', 'datalogics_shipping' );
//     return $actions;
// }

// Make the action from selected orders
// add_filter( 'handle_bulk_actions-edit-shop_order', 'datalogics_handle_bulk_action', 10, 3 );
// function datalogics_handle_bulk_action( $redirect_to, $action, $post_ids ) {
//     $settings = datalogics_settings_return();
//     if ( $action !== 'datalogics_bulk_send_shipping' )
//         return $redirect_to; // Exit

//     $error = 0;
//     //Settings validation
//     $settings = datalogics_settings_return();
//     foreach ($settings as $key => $value) {
//         if($value == '' && $key != 'shipping_push_products_in_comments' && $key != 'datalogics_api_key' && $key != 'datalogics_api_secret')
//             $error = 1;
//     }
//     $processed_ids = [1];
//     //Sending for each order


//     foreach ( $post_ids as $post_id ) {

//         $shipping_method = datalogics_check_allowed_shipping($post_id);
//         if ($shipping_method == false) {
//             continue;
//         }

//         $result = datalogics_create_shipping($post_id);
//         $success = 0;
//         if ($result == 0) {

//             $success = 2;

//         } else if (is_wp_error($result)) {

//             $success = 0;

//         } else {

//             $success = json_decode($result['http_response']->get_response_object()->body)->success;

//         }

//         if ($success == 1) {

//             $processed_ids[] = $post_id;

//         } else if ($success == 0) {

//             $error = 2;

//         } else {

//             continue;

//         }
//     }

//     //Action if there is no error
//     if($error < 1){
//         return $redirect_to = add_query_arg( array(
//             'datalogics_bulk_send_shipping' => '1',
//             'processed_count' =>  [],//$processed_ids,
//             'processed_ids' => '',//implode( ',', $processed_ids ),
//         ), $redirect_to );
//     }
//     //Action if error = 1, wrong settings
//     else if ($error == 1) {
//         return $redirect_to = add_query_arg( array(
//             'datalogics_bulk_send_shipping' => '0',
//             'processed_count' =>  [],//$processed_ids,
//             'processed_ids' => '',//implode( ',', $processed_ids ),

//         ), $redirect_to );
//     }
//     //Action if error = 2, connection not possible
//     else {
//         return $redirect_to = add_query_arg( array(
//             'datalogics_bulk_send_shipping' => '2',
//             'processed_count' =>  [],//$processed_ids,
//             'processed_ids' => '',//implode( ',', $processed_ids ),

//         ), $redirect_to );
//     }
// }

// The results notice from bulk action on orders
add_action( 'admin_notices', 'downloads_bulk_action_admin_notice' );
function downloads_bulk_action_admin_notice(){
    if (isset($_REQUEST['datalogics_bulk_send_shipping']) ){
        if($_REQUEST['datalogics_bulk_send_shipping'] == '1'){
            $count = count( $_REQUEST['processed_count'] ) - 1;

            printf( '<div id="message" class="updated fade"><p>' .
                _n( 'Processed %s Order for shipping.',
                    'Processed %s Orders for shipping.',
                    $count,
                    'datalogics_shipping'
                ) . '</p></div>', $count );
        }
        else if($_REQUEST['datalogics_bulk_send_shipping'] == '2'){
            printf( '<div id="message" class="error fade"><p>'.__('Unable to connect, please contact plugin vendor.', 'datalogics_shipping').'</p></div>');
        }
        else{
            $path = 'admin.php?page=datalogics-settings';
            $settings_url = admin_url($path);
            printf( '<div id="message" class="error fade"><p>'.__('You didnt finish your configuration, please go to <a href='.$settings_url.'>settings</a> and complete the configuration!','datalogics_shipping').'</p></div>');

        }
    }
}





add_action( 'wp_ajax_datalogics_track_shipping', 'datalogics_track_shipping' );
add_action( 'wp_ajax_nopriv_datalogics_track_shipping', 'datalogics_track_shipping' );

function datalogics_track_shipping($returnJsonData=true)
{
    $result = [
        'success' => 0
    ];

    $order_id    = $_POST['order_no'];
    $shipping_id = $_POST['shipping_no'];


    $url = 'https://connect.datalogics.co.il/rest/w_get_shipping_status';


    $data['token']    = get_option('datalogics_token', '');
    $data['order_id'] = $order_id;

    $result = wp_remote_post($url,
        array(
            "headers" => [
                'Content-Type' => 'text/xml',
            ],
            "body" => json_encode($data),
            "sslverify" => false,
            'timeout'    => 30, 
        )
    );

    

    if(!is_wp_error($result))
    {


        //var_dump($_POST,$data,$result['http_response']->get_response_object()->body);

        $result_array = json_decode($result['http_response']->get_response_object()->body,true);





        //var_dump($result_array);

        

        if($result_array['success'])
        {
            

            $order                  = wc_get_order( $order_id );
            if (is_object($order)) {

                $order             = $order->get_data();
                
                if ($order['id']>0) {


                    $datalogics_shipping = get_post_meta( $order_id, 'datalogics_shipping', true);                
                    if ($datalogics_shipping=='') 
                    {
                        $datalogics_shipping = [];
                    } else {
                        if (is_string($datalogics_shipping)) {  
                            $datalogics_shipping = json_decode($datalogics_shipping,true);
                        }
                    }         
                    
                    //var_dump($datalogics_shipping);

                    $tracking_number = '';

                    if (!empty($datalogics_shipping)) {
                        $tracking_number = $datalogics_shipping['tracking_number'];
                    }


                    //$order_data             = $order->get_data();
                    $tracking = '';
                    $order_tracking_status = [];

                    $order_tracking_status = $result_array['data'];

                    $tracking    = $tracking_number;
                    //$shipment_id = $tracking;

                    /*
                    foreach($result_array['data'] as $status) {

                        $order_tracking_status[] = [
                            'tracking_number'=>

                    }
                    */

                    /*
                    foreach($order['meta_data'] as $meta) {
                        

                        $meta = (array)$meta;
                        $meta = end($meta);

                        if ($meta['key']=='datalogics_shipping') {

                            //var_dump($meta['value']);

                            $data = json_decode($meta['value']);
                            foreach($data as $shipment) {
                                if ($shipping_id==$shipment->tracking_number){
                                    $tracking = $shipment->tracking_number;
                                }
                            }

                        }   
                        
                        if ($meta['key']=='datalogics_shipping_status') {

        
                            $data = json_decode($meta['value']);
                            //var_dump($shipping_id,$data);
                            foreach($data as $status) {
                                if ($shipping_id==$status->tracking_number){
                                    $order_tracking_status[] = $status;
                                }
                            }
                            
                            //var_dump($meta['value']);
                        }


                        
                    }
                    */



                    $result = ['success'=>0];
                    if ($tracking==$shipping_id && $tracking!='' && $shipping_id!='') {

                        $result = [
                            'success' => 1,
                            'tracking_number' => $tracking,
                            'status'=> $order_tracking_status,
                            'firstname' =>  ($order['shipping']['first_name']!='') ? $order['shipping']['first_name'] : $order['billing']['first_name'],
                            'lastname' => ($order['shipping']['last_name']='') ? $order['shipping']['last_name'] : $order['billing']['last_name'],
                            'company' => ($order['shipping']['company']!='') ? $order['shipping']['company'] : $order['billing']['company'],
                            'address1' => ($order['shipping']['address_1']!='') ? $order['shipping']['address_1'] : $order['billing']['address_1'],
                            'address2' => ($order['shipping']['address_2']!='') ? $order['shipping']['address_2'] : $order['billing']['address_2'],
                            'city' => ($order['shipping']['address_2']!='') ? $order['shipping']['address_2'] : $order['billing']['address_2'],
                            'total' => $order['total'],
                            'date'=> date("Y-m-d",strtotime($order['date_modified'])),
                            'data'=> $result_array['data'],

                        ];

                    } 
                    // else if ($try<1) {

                    //     $data = ['order_id'=>$order_id];

                    //     $url = 'https://connect.datalogics.co.il/rest/w_get_shipping_status';

                    //     $result = wp_remote_post($url,
                    //         array(
                    //             "headers" => [
                    //                 'Content-Type' => 'text/xml',
                    //             ],
                    //             "body" => json_encode($data),
                    //             "sslverify" => false,
                    //         )
                    //     );

                    //     datalogics_track_shipping(1);

                    // }

                    if ($returnJsonData==true) {

                        wp_send_json($result);
                        die;

                    }
                    

                }

            }

        }

    }

    if ($returnJsonData==true) {

        $result = [
            'success' => 0
        ];

        wp_send_json([]);
        die;
        
    }

    return $result;
}






add_action( 'wp_ajax_datalogics_create_shipping', 'datalogics_create_shipping' );
//add_action( 'wp_ajax_nopriv_datalogics_create_shipping', 'datalogics_create_shipping' );

// Create shipping function

function getProtectedValue($obj, $name) {
    $array = (array)$obj;
    $prefix = chr(0).'*'.chr(0);
    return $array[$prefix.$name];
}

function datalogics_create_shipping($order_id = 0, $govina = '', $comment = '',$auto=''){

    if (!isset($_POST)) {
        $_POST = [];
    }

    if (isset($_POST['datalogics_order_id']) && $_POST['datalogics_order_id']!='') {
        $order_id = $_POST['datalogics_order_id'];
    }

    if(!$order_id){
        $order_id   = $_POST['datalogics_order_id'];
    }


    $shipping_method = datalogics_check_allowed_shipping($order_id);

    if ($shipping_method == false) {

        if(isset($_POST['datalogics_order_id'])) {
            wp_send_json([]);
        } else {
            return 0;
        }

    }


    $order                  = wc_get_order( $order_id );
    $order_data             = $order->get_data(); 
    

    $infoArray = datalogicsGetOrderInfo($order_id );  
    foreach($infoArray as $key=>$value) {

        $$key = $value;

    }


    $tempData = [];


    if ($_POST['datalogics_email']=='') 
        $_POST['datalogics_email'] =  $infoArray['email'];
                    
    if ($_POST['datalogics_address']=='') 
        $_POST['datalogics_address']  = $infoArray['address1'];
    
    if ($_POST['datalogics_house']=='')     
        $_POST['datalogics_house']    = $infoArray['address2'];
    
    if ($_POST['datalogics_city']=='') 
        $_POST['datalogics_city']     = $infoArray['city'];
    
    if ($_POST['datalogics_phone']=='') 
        $_POST['datalogics_phone']    = $infoArray['phone'];
    
    if ($_POST['datalogics_fullname']=='') 
        $_POST['datalogics_fullname'] = $infoArray['fullname'];

    if ($_POST['datalogics_apartment']=='') 
        $_POST['datalogics_apartment'] = $infoArray['apartment'];
    
    if ($_POST['datalogics_entrance']=='') 
        $_POST['datalogics_entrance'] = $infoArray['entrance'];
    
    if ($_POST['datalogics_floor']=='') 
        $_POST['datalogics_floor'] = $infoArray['floor'];

    if ($_POST['datalogics_platform_id']=='') {

        $exist_companies = get_option('datalogics_shipping_method');

        if ($exist_companies!='') {

            $exist_companies = json_decode($exist_companies,true); 

            foreach($exist_companies as $company) {

                //$data['shipping_platform_id'] = urldecode($company['name']);
                $_POST['datalogics_platform_id'] = $company['shipping_push_supplier'];
                break;
                
            } 

        }

    }



    if (isset($_POST['datalogics_location'])) {

        update_post_meta($order_id, 'datalogics_location', $_POST['datalogics_location']);

    }


    
    if (isset($_POST['datalogics_govina'])) {

        update_post_meta($order_id, 'datalogics_govina', $_POST['datalogics_govina']);

    }

    if (isset($_POST['datalogics_govina_sum'])) {

        update_post_meta($order_id, 'datalogics_govina_sum', $_POST['datalogics_govina_sum']);

    }

    if (isset($_POST['datalogics_comment'])) {

        update_post_meta($order_id, 'datalogics_comment', $_POST['datalogics_comment']);

    }

    if (isset($_POST['datalogics_packs'])) {

        update_post_meta($order_id, 'datalogics_packs', $_POST['datalogics_packs']);

    }

    if (isset($_POST['datalogics_user'])) {

        update_post_meta($order_id, 'datalogics_user', $_POST['datalogics_user']);

    }

    ///var_dump($_POST['datalogics_platform_id']);

    if (isset($_POST['datalogics_platform_id'])) {

        //var_dump($_POST['datalogics_platform_id']);

        update_post_meta($order_id, 'datalogics_platform_id', $_POST['datalogics_platform_id']);

    }

    if (isset($_POST['datalogics_shipment_type'])) {

        update_post_meta($order_id, 'datalogics_shipment_type', $_POST['datalogics_shipment_type']);


    }



    if (isset($_POST['datalogics_carrier_type'])) {

        update_post_meta($order_id, 'datalogics_carrier_type', $_POST['datalogics_carrier_type']);

    }

    if (isset($_POST['datalogics_fullname'])) {

        update_post_meta($order_id, 'datalogics_fullname', $_POST['datalogics_fullname']);

    }

    if (isset($_POST['datalogics_phone'])) {

        update_post_meta($order_id, 'datalogics_phone', $_POST['datalogics_phone']);

    }

    if (isset($_POST['datalogics_address'])) {

        update_post_meta($order_id, 'datalogics_address', $_POST['datalogics_address']);

    }
    if (isset($_POST['datalogics_house'])) {

        update_post_meta($order_id, 'datalogics_house', $_POST['datalogics_house']);

    }
    if (isset($_POST['datalogics_city'])) {

        update_post_meta($order_id, 'datalogics_city', $_POST['datalogics_city']);

    }
    if (isset($_POST['datalogics_email'])) {

        update_post_meta($order_id, 'datalogics_email', $_POST['datalogics_email']);

    }

    if (isset($_POST['datalogics_apartment'])) {

        update_post_meta($order_id, 'datalogics_apartment', $_POST['datalogics_apartment']);

    }

    if (isset($_POST['datalogics_entrance'])) {

        update_post_meta($order_id, 'datalogics_entrance', $_POST['datalogics_entrance']);

    } 

    if (isset($_POST['datalogics_floor'])) {

        update_post_meta($order_id, 'datalogics_floor', $_POST['datalogics_floor']);

    } 
    
    if ($auto==1 || !isset($_POST['datalogics_n_code']))
    {
        $_POST['datalogics_n_code'] = get_post_meta($order_id, 'datalogics_n_code',true);
    }



    if (isset($_POST['datalogics_n_code']))
    {
        

        $ncode_ex = explode("-",$_POST['datalogics_n_code']);

        //var_dump($ncode_ex);


        //update_post_meta($order_id, '$ncode_ex', $ncode_ex);
        

        if (count($ncode_ex)==2) {

            $_POST['datalogics_n_code'] = $ncode_ex[1];
            $_POST['datalogics_platform_id'] = $ncode_ex[0];

            update_post_meta($order_id, 'datalogics_n_code', $ncode_ex[1]);
            update_post_meta($order_id, 'datalogics_platform_id', $ncode_ex[0]);

        } else if ($_POST['datalogics_n_code']!='') {

            update_post_meta($order_id, 'datalogics_n_code', $_POST['datalogics_n_code']);

        } else {

            update_post_meta($order_id, 'datalogics_n_code', '');

        }        

    }

    // var_dump($_POST);

    // die('111111');


    // if ($order_id==16392) {

    //     $ncode_ex = get_post_meta($order_id, 'datalogics_n_code',true);

    //     var_dump('test',$ncode_ex); die;
    // }

    


    $url                    = 'https://connect.datalogics.co.il/rest/w_create_shipping';
    $data                   = array();

    if (isset($_POST) && is_array($_POST)) {
        $data['meta'] = $_POST;
    }

    $order                  = wc_get_order( $order_id );
    $order_data             = $order->get_data();


    $shipping_lines = array();
    foreach ($order->get_items('shipping') as $item_id => $shipping_item) {
        $shipping_lines[] = $shipping_item->get_data();
    }



    $order_data['shipping_lines'] = $shipping_lines;


    $order_data['line_items'] = [];
    foreach($order->get_items() as $key=>$item) {

        $item_data = $item->get_data();

        if (!isset($item_data['sku']) || empty($item_data['sku'])) {
            $product = $item->get_product();
            $item_data['sku'] = $product ? $product->get_sku() : '';
        }

        $order_data['line_items'][$item->get_id()] = $item_data;
        //$order_data['line_items'][$item->get_id()]->sku = $item->sku;

        if (isset($item['meta_data']) && count($item['meta_data'])>0) {

            $order_data['line_items'][$item->get_id()]['meta_data'] = [];

            foreach($item['meta_data'] as $meta) {

                $order_data['line_items'][$item->get_id()]['meta_data'][] = $meta->get_data();

            }

        }
    }

    // var_dump( $order_data['line_items']);

    // return;


    $data['order'] = $order_data;

    // $data['city']                   = get_post_meta( $order_id, 'datalogics_city', true );
    // $data['house']                  = get_post_meta( $order_id, 'datalogics_house', true );
    // $data['address']                = get_post_meta( $order_id, 'datalogics_address', true );
    // $data['phone']                  = get_post_meta( $order_id, 'datalogics_phone', true );    
    // $data['email']                  = get_post_meta( $order_id, 'datalogics_email', true );
    // $data['fullname']               = get_post_meta( $order_id, 'datalogics_fullname', true );
    // $data['carrier_type']           = get_post_meta( $order_id, 'datalogics_carrier_type', true );
    // $data['location']               = get_post_meta( $order_id, 'datalogics_location', true );
    // $data['shipment_type']          = get_post_meta( $order_id, 'datalogics_shipment_type', true );
    // $data['shipping_platform_id']   = get_post_meta( $order_id, 'datalogics_platform_id', true );
    // $data['comment']                = get_post_meta( $order_id, 'datalogics_comment', true );
    // $data['govina']                 = get_post_meta( $order_id, 'datalogics_govina', true );
    // $data['govina_sum']             = get_post_meta( $order_id, 'datalogics_govina_sum', true );
    // $data['packs']                  = get_post_meta( $order_id, 'datalogics_packs', true );
    // $data['user']                   = get_post_meta( $order_id, 'datalogics_user', true );

    $data['token']                  = get_option('datalogics_token', '');
    $data['settings']               = datalogics_settings_return();

    // if (isset($data['settings']['shipping_method'])) {
    //     $data['settings']['shipping_method'] = json_decode($data['settings']['shipping_method'],true);
    // }
   
    $result = 0;

    // var_dump($data);

    // return;

    // var_dump(json_encode($data));
    // die;

    //var_dump(11114);
    //var_dump(11114);

    $result = wp_remote_post($url,
        array(
            "headers" => [
                'Content-Type' => 'text/xml',
            ],
            "body" => json_encode($data),
            "sslverify" => false,
            'timeout'    => 30, 
        )
    );

    //var_dump(11114);

    if(!is_wp_error($result))
    {

        $result_array = json_decode($result['http_response']->get_response_object()->body,true);

        if($result_array['success'])
        {

            // if ($result_array['label_url']=='') {
            //     $result_array['label_url'] = PRINT
            // }

            //var_dump(11114);

            //var_dump($result_array);

            if (isset($result_array['tracking_number']) && $result_array['tracking_number']!='') {
                $result_array['msg'] = '';
            }

            if (isset($result_array['label_url']) && strpos($result_array['label_url'],'https:/Baldar/DeliveryLabel')!==false) {
                $result_array['label_url'] = '';
            }

            //var_dump($result_array);

            $exist_datalogics_shipping = json_encode( $result_array);

            //var_dump($exist_datalogics_shipping);

            //var_dump( $order_id, 'datalogics_shipping', $exist_datalogics_shipping);

            update_post_meta( $order_id, 'datalogics_shipping', $exist_datalogics_shipping);

            // try {
                
            //     update_post_meta($order_id, 'datalogics_shipping', $exist_datalogics_shipping);

            // } catch (Exception $e) {
                
            //     error_log('Error updating post meta: ' . $e->getMessage());
            // }

            ///var_dump(11114);
            
        }
    }
    
    //    datalogics_create_api($_POST['datalogics_api_nonce']);

    if(isset($_POST['datalogics_order_id'])) {
       
        wp_send_json($result);
    } else {
        
        return $result;
    }
}

// Cancel shipping function
add_action( 'wp_ajax_datalogics_cancel_shipping', 'datalogics_cancel_shipping' );
//add_action( 'wp_ajax_nopriv_datalogics_cancel_shipping', 'datalogics_cancel_shipping' );

function datalogics_cancel_shipping($order_id = 0, $govina = '', $comment = ''){

    $url = 'https://connect.datalogics.co.il/rest/w_cancel_shipping';
    $data = array();

    if($order_id==0 || $order_id==''){       

        $order_id                           = $_POST['datalogics_order_id'];
        $data['datalogics_tracking_number'] = $_POST['datalogics_tracking_number'];
    }
    else{
        $data['datalogics_tracking_number'] = '';
    }

    $order                  = wc_get_order( $order_id );
    $order_data             = $order->get_data();
    $datalogics_shipping    = get_post_meta( $order_id, 'datalogics_shipping', true );
           
    if ($datalogics_shipping=='') {

        $datalogics_shipping = [];

    } else {

        $datalogics_shipping = json_decode($datalogics_shipping,true);

    }    
    

    $data['token'] = get_option('datalogics_token', '');
    $data['order'] = $order_data;
    $data['settings'] = datalogics_settings_return();
    $result = 0;

    

    if (isset($datalogics_shipping['tracking_number']) && $datalogics_shipping['tracking_number']==$data['datalogics_tracking_number'])
    {


        $result = wp_remote_post($url,
            array(
                "headers" => [
                    'Content-Type' => 'text/xml',
                ],
                "body" => json_encode($data),
                "sslverify" => false,
                "timeout"=>60
            )
        );


        if(!is_wp_error($result))
        {
            $success = json_decode($result['http_response']->get_response_object()->body)->success;
            
            if($success)
            {                   

                $datalogics_shipping_update = [];

                update_post_meta( $order_id, 'datalogics_shipping', $datalogics_shipping_update);                    

            }
        }

    }

    
    if(isset($_POST['datalogics_order_id']))
    {
        wp_send_json($result);

    } else {

        return $result;
    }
}

//API key and secret creation if not exist
add_action( 'wp_ajax_datalogics_create_api', 'datalogics_create_api' );
add_action( 'wp_ajax_nopriv_datalogics_create_api', 'datalogics_create_api' );
function datalogics_create_api(){

    if (get_option('datalogics_api_key')=='') {

        $cookies = array();
        foreach ($_COOKIE as $name => $val)
        {
            $cookies[] = "$name=" . urlencode(is_array($val) ? serialize($val) : $val);
        }
        $cookies = implode('; ', $cookies);

        $request_args = array(
            'sslverify' => false,//apply_filters('https_local_ssl_verify', true),
            'body' => array(
                'action' => 'woocommerce_update_api_key',
                'description' => esc_html__('Datalogics Access', 'datalogics_shipping'),
                'permissions' => 'read_write',
                'user' => get_current_user_id(),
                'security' => wp_create_nonce('update-api-key'),
            ),
            'timeout' => 60,
            'headers' => array(
                'cookie' => $cookies,
            ),
        );

        $response   = wp_remote_post(admin_url('admin-ajax.php'), $request_args);
        $code       = wp_remote_retrieve_response_code($response);
        $body       = json_decode(wp_remote_retrieve_body($response));

        if (
            200 === intval($code)
            && !empty($body->success)
            && !empty($body->data->consumer_key)
            && !empty($body->data->consumer_secret)
        ) {

            update_option('datalogics_api_key', $body->data->consumer_key);
            update_option('datalogics_api_secret', $body->data->consumer_secret);

            return (array)$body->data;
        }

    }

    return array();



}
//Cron for updating locations
//Adding our schedule minutes
function datalogics_set_crons(){

    $minutes = 30;

    if(!isset($schedules["datalogics_get_stores_cron"])){
        $schedules["datalogics_get_stores_cron"] = array(
            'interval' => $minutes * 60,
            'display' => __('Once every '.$minutes. 'minutes'));
    }

    $minutes = 720;

    if(!isset($schedules["datalogics_shipping_companies"])){
        $schedules["datalogics_shipping_companies"] = array(
            'interval' => $minutes * 60,
            'display' => __('Once every '.$minutes. 'minutes'));
    }

    $minutes = 30;

    if(!isset($schedules["datalogics_shipping_auto_retry"])){
        $schedules["datalogics_shipping_auto_retry"] = array(
            'interval' => $minutes * 60,
            'display' => __('Once every '.$minutes. 'minutes'));
    }

    $minutes = 1440;
    if(!isset($schedules["datalogics_shipping_streets_csv"])){
        $schedules["datalogics_shipping_streets_csv"] = array(
            'interval' => $minutes * 60,
            'display' => __('Once every '.$minutes. 'minutes'));
    }




    return $schedules;
}
add_filter('cron_schedules','datalogics_set_crons');



//Scheduling our hook
if (!wp_next_scheduled('datalogics_update_locations_schedule')) {
    wp_schedule_event( time(), 'datalogics_get_stores_cron', 'datalogics_update_locations_schedule' );
}
add_action ('datalogics_update_locations_schedule', 'datalogics_update_locations' );


//Scheduling our hook
if (!wp_next_scheduled('update_get_datalogics_shipping_companies_schedule')) {
    wp_schedule_event( time(), 'datalogics_shipping_companies', 'update_get_datalogics_shipping_companies_schedule' );
}
add_action ('update_get_datalogics_shipping_companies_schedule', 'get_datalogics_shipping_companies' );

//Scheduling our hook
if (!wp_next_scheduled('datalogics_shipping_auto_retry_schedule')) {
    wp_schedule_event( time(), 'datalogics_shipping_auto_retry', 'datalogics_shipping_auto_retry_schedule' );
}
add_action ('datalogics_shipping_auto_retry_schedule', 'datalogics_shipping_auto_retry_sending' );

//Scheduling our hook
if (!wp_next_scheduled('datalogics_shipping_streets_csv_schedule')) {
    wp_schedule_event( time(), 'datalogics_shipping_streets_csv', 'datalogics_shipping_streets_csv_schedule' );
}
add_action ('datalogics_shipping_streets_csv_schedule', 'datalogics_shipping_streets_csv_get' );

if (isset($_GET) && isset($_GET['streets'])) {

    datalogics_shipping_streets_csv_get();

}

function datalogics_shipping_streets_csv_get() {

    // $baseUrl = 'https://data.gov.il';

    // $url = $baseUrl . '/dataset/321/resource/9ad3862c-8391-4b2f-84a4-2d4c68625f4b';    

    // $re = '/<a class="resource-url-analytics resource-type-None" href="(.*)">/m';

    // preg_match_all($re, $str, $matches, PREG_SET_ORDER, 0);


    // file_put_contents(
    //     plugin_dir_path(__FILE__) . 'includes/data.csv',
    //     file_get_contents( $url )
    // );


    $url = 'https://connect.datalogics.co.il/rest/w_get_streets_version';

    $data = [];
    $data['token'] = get_option('datalogics_token', '');
    //var_dump($data);
    $result = wp_remote_post($url,
        array(
                "headers" => [
                    'Content-Type' => 'text/xml',
                ],
                "body" => json_encode($data),
                "sslverify" => false,
        )
    );

    if(!is_wp_error($result)){

        $response = json_decode($result['http_response']->get_response_object()->body);
        //var_dump($response);
        if($response->success){

            if($response->success==1){


                

                $version = get_option('datalogics_streets_version', '');
                if ($version != $response->version) {

                    // file_put_contents(
                    //     plugin_dir_path(__FILE__) . 'includes/data.csv',
                    //     file_get_contents( 'https://connect.datalogics.co.il/files/streets.csv' )
                    // );                

                    update_option('datalogics_streets_version', $response->version);
                }

            }

        }
    }

}

function datalogics_shipping_auto_retry_sending()
{

    return;

    $datalogics_order_status = get_option('shipping_order_status', '');

    if ($datalogics_order_status==''){
        return;
    }

    //$datalogics_order_status_temp   = str_replace("wc-","",$datalogics_order_status);

    

    $args = array(
        'limit' => 10,
        //'return' => 'ids',
        'order' => 'DESC',
        'meta_query' => array(
            array(
                'key' => 'datalogics_shipping',
                'value' => '',
                'compare' => '=',
            ),
        ),
        'status' => array($datalogics_order_status)
    );    

    $last_order_id = get_option('order_statuses_limit','');
    
    $query = new WC_Order_Query( $args );
    $orders = $query->get_orders();

    if (count($orders)>0) {
  
        
        foreach( $orders as $order ) {  
            
            if ($order->id > $last_order_id || $last_order_id=='') {

                $shipping_method = datalogics_check_allowed_shipping($order->id);

                if ($shipping_method == false) {
                    continue;
                }

                datalogics_create_shipping($order->id,'','',1);

            }

        }
    }
}




add_action( 'wp_ajax_datalogics_get_close_locations', 'datalogics_get_close_locations' );
add_action( 'wp_ajax_nopriv_datalogics_get_close_locations', 'datalogics_get_close_locations' );



function datalogics_get_close_locations() {

    $mylat = $_POST['lat'];
    $mylong = $_POST['long'];
    // $locations_by_platform = unserialize(get_option('datalogics_shipping_locations'));
    $locations_by_platform = get_option('datalogics_shipping_locations');
    if ($locations_by_platform!='' && !is_array($locations_by_platform)) {
        $locations_by_platform = unserialize($locations_by_platform);
    }
    $existing_companies = get_option('datalogics_shipping_method', '');
    $existing_companies = json_decode($existing_companies,true); 


    //wp_send_json($locations[$city]);

    $locations_by_km = [];

    foreach ($locations_by_platform as $platform_id => $locations){

        $company_exist_check = false;
    
        foreach($existing_companies as $exist_company) {

            if ($exist_company['shipping_push_supplier']==$platform_id) {

                $company_exist_check = true;

            }

        }

        if ($company_exist_check == false) {
            continue;
        }

        foreach ($locations as $city => $values){

            foreach ($values as $key => $value) {

                $deslat = (float)$value['latitude'];
                $deslong = (float)$value['longitude'];

                $distance = Distance($mylat,$mylong,$deslat,$deslong);

                $distance = number_format((float)$distance, 2, '.', '');
                ob_start();
                ?>
                <div class="datalogics_pickup_checkout_mid_list_row list-icon list-icon17" data-platform-id="<?php echo $platform_id?>" data-ncode="<?php echo sanitize_text_field($value['n_code']) ?>"
                    onclick="setLocation('<?php echo $deslat ?>','<?php echo $deslong; ?>')">
                    <div>
                        <span class="list-marker-icon"></span>
                    </div>
                    <div>
                        <strong><?php echo $value['name'] ?> (<?php echo $distance;?> <?php echo __('km','datalogics_shipping')?>)</strong><br>
                        <?php echo $value['street'] ?> <?php echo $value['house'] ?>
                        ,<?php echo $value['city'] ?>.<br>
                        <?php if (!is_array($value['remarks']) && $value['remarks'] !='') { ?>
                            <?php echo $value['remarks'] ?>
                        <br>
                        <?php } ?>
                        <?php
                        /*
                        <?php echo __('Distance from destination','datalogics')?> <strong><?php echo $distance;?> <?php echo __('km','datalogics')?></strong>
                        */
                        ?>
                        <button class="button" onclick="selectLocation('<?php echo sanitize_text_field(str_replace('"','',$value['name'])) ?>','<?php echo sanitize_text_field($value['street']) ?>','<?php echo sanitize_text_field($value['house']) ?>','<?php echo sanitize_text_field($value['city']) ?>','<?php echo sanitize_text_field($value['n_code']) ?>','<?php echo $platform_id?>')"><?php echo __('Choose Location', 'datalogics_shipping'); ?></button>
                    </div>
                </div>
                <?php
                $locations_by_km[$distance] = ob_get_clean();
                // echo __('Choose Location', 'datalogics_shipping');
            }
        }

    }

    ksort($locations_by_km);
    $limit = 20;
    $counter = 0;
    foreach($locations_by_km as $location) {

        echo $location;

        $counter++;

        if ($counter>=  $limit) {
            break;
        }

    }

    return;


    //wp_send_json($locations);
}



add_action( 'woocommerce_product_options_inventory_product_data', 'datalogics_optical_woocommerce_product_custom_fields' );


$datalogics_pickup_allowed = 'datalogics_pickup_allowed';

function datalogics_optical_woocommerce_product_custom_fields () {

    global $woocommerce, $post,$datalogics_pickup_allowed;

    echo '<div class="product_custom_field">';

    $options = [
        ''=>__('Choose', 'datalogics_shipping'),
        '0'=>__('Yes', 'datalogics_shipping'),
        '1'=>__('No', 'datalogics_shipping')
    ];

    $value = get_post_meta( $post->ID, $datalogics_pickup_allowed, true );

    woocommerce_wp_select(array(
        'id' => $datalogics_pickup_allowed,
        'label' => __('Datalogics Available for pickup locations?', 'datalogics_shipping'),
        'options' => $options, //this is where I am having trouble
        'value' => $value,
    ));


    echo '</div>';


}

add_action( 'woocommerce_process_product_meta', 'datalogics_pickup_woocommerce_product_custom_fields_save' );

function datalogics_pickup_woocommerce_product_custom_fields_save($post_id)
{
    global $datalogics_pickup_allowed;


    $woocommerce_custom_product_text_field = $_POST[$datalogics_pickup_allowed];

    update_post_meta($post_id, $datalogics_pickup_allowed, esc_attr($woocommerce_custom_product_text_field));


}

function get_datalogics_shipping_companies(){

    $url = 'https://connect.datalogics.co.il/rest/w_get_shipping_companies';

    $data = [];
    $data['token'] = get_option('datalogics_token', '');
    $result = wp_remote_post($url,
        array(
                "headers" => [
                    'Content-Type' => 'text/xml',
                ],
                "body" => json_encode($data),
                "sslverify" => false,
        )
    );
    //var_dump($result);
    if(!is_wp_error($result)){

        $response = json_decode($result['http_response']->get_response_object()->body);
        //var_dump($response);
        if($response->success){

            if($response->success==1){
                
                $datalogics_shipping_companies = json_encode($response->data);
                update_option('datalogics_shipping_companies', $datalogics_shipping_companies);

            }

        }
    }

}



add_filter( 'update_post_metadata', function( $check, $object_id, $meta_key, $meta_value ) {

    // Already short-circuited; bail.
    if ( null !== $check ) {
        return $check;
    }

    if (get_option('datalogics_myaccount_tracking_email','')) {

        if ( 'datalogics_shipping' == $meta_key ) {

            if ( ! empty( $meta_value ) && $meta_value!='') {       
                
                //plugins_url(dirname( __FILE__ ))

                require_once dirname( __FILE__ )  .'/../woocommerce/includes/emails/class-wc-email.php';

                require_once dirname( __FILE__ ) .'/'. 'class_wc_shipping_order_email.php';

                $email = new WC_Shipping_Order_Email();
                $email->trigger($object_id);


                //do_action('datalogics_shipping_customer_shipping_email', $object_id);

            }

        }

    }


    return $check;    
    // Prevent saving empty value to user's 'foo' metadata.
    return false;
}, 10, 4 );    





add_filter( 'woocommerce_email_classes', 'filter_woocommerce_email_classes' );
function filter_woocommerce_email_classes( array $email_classes ): array {

    //var_dump(dirname( __FILE__ ));
    
    require_once dirname( __FILE__ ) .'/'. 'class_wc_shipping_order_email.php';

    $email_classes['WC_Shipping_Order_Email'] = new WC_Shipping_Order_Email();   
    

    return $email_classes;
}

// Add custom information to order email
function datalogics_add_custom_information_to_order_email($order, $sent_to_admin, $plain_text, $email) {
    // Get the custom information from your source (e.g., custom meta field)


    $ncode_platform_id = get_post_meta($order->get_id(), 'datalogics_n_code_platform_id',true);

    $datalogics_n_code = get_post_meta($order->get_id(), 'datalogics_n_code',true);

    $ncode_ex = explode("-",$datalogics_n_code);    
    
    //var_dump($ncode_ex);

    if (count($ncode_ex)==2) {
        $datalogics_n_code = $ncode_ex[1];
        $ncode_platform_id = $ncode_ex[0];
    } 

    //$ncode_list = unserialize(get_option('datalogics_shipping_locations')); 

    $ncode_list = get_option('datalogics_shipping_locations');
    if ($ncode_list!='' && !is_array($ncode_list)) {
        $ncode_list = unserialize($ncode_list);
    }
                       
    if (isset($ncode_list)) {  
        $ncode_list_pass = false;
        foreach ($ncode_list as $platform_id => $locations){ 
            if (!empty($locations)) {
                $ncode_list_pass = true; 
                break; 
            }
        }
        if ($ncode_list_pass==true) {

            foreach ($ncode_list as $platform_id => $locations){                                                        
                foreach ($locations as $values){
                    foreach($values as $value) {

                        if($value['n_code']==$datalogics_n_code && $platform_id==$ncode_platform_id) {

                            // Display the custom information in the email template
                            echo '<h2>'.__('Custom Information:','datalogics_shipping').'</h2>';
                            echo '<p>';
                            echo __('Pick your order from pickup location:','datalogics_shipping');
                            echo $value['name'] .', '.$value['city'].', '.$value['street'];
                            if (isset($value['remarks'])) {
                                echo '<br>' . $value['remarks'];
                            }
                            echo '</p>';

                        }
                    }
                }
            }
        }
    }

}
add_action('woocommerce_email_after_order_table', 'datalogics_add_custom_information_to_order_email', 10, 4);



function datalogicsGetOrderInfo($order_id) {

    $order = wc_get_order( $order_id );
    $order = $order->get_data();

    $email =  $order['billing']['email'];

    if ($order['shipping']['address_1']!='' && $order['shipping']['city']!='') {

        $address1 = $order['shipping']['address_1'];
        $address2 = $order['shipping']['address_2'];
        $company  = $order['shipping']['company'];
        $city     = $order['shipping']['city'];
        $phone    = $order['shipping']['phone'];
        $fullname = $order['shipping']['first_name'] . ' ' .$order['shipping']['last_name'];
        $apartment= '';
        $entrance = '';
        $floor = '';
        $door = '';

        if ($order['shipping']['phone']=='') {
            $phone = $order['billing']['phone'];
        }


        $datalogics_shipping_map_street     = get_option('datalogics_shipping_map_street', '');
        $datalogics_shipping_map_house      = get_option('datalogics_shipping_map_house', '');
        $datalogics_shipping_map_apartment  = get_option('datalogics_shipping_map_apartment', '');
        $datalogics_shipping_map_entrance   = get_option('datalogics_shipping_map_entrance', '');
        $datalogics_shipping_map_floor       = get_option('datalogics_shipping_map_floor', '');
        $datalogics_shipping_map_door        = get_option('datalogics_shipping_map_door', '');

        if ($datalogics_shipping_map_apartment=='address_1')
        {
            $apartment = $address1;
        }
        if ($datalogics_shipping_map_apartment=='address_2')
        {
            $apartment = $address2;
        }
        if ($datalogics_shipping_map_entrance=='address_1')
        {
            $entrance = $address1;
        }
        if ($datalogics_shipping_map_entrance=='address_2')
        {
            $entrance = $address2;
        }
        if ($datalogics_shipping_map_floor=='address_1')
        {
            $floor = $address1;
        }
        if ($datalogics_shipping_map_floor=='address_2')
        {
            $floor = $address2;
        }



        foreach($order['meta_data'] as $meta) 
        {     
            
            $meta = (array)$meta;
            $meta = end($meta);

            if ($datalogics_shipping_map_street!='' && 
                    $datalogics_shipping_map_street!='address_1' && 
                        $meta['key']==$datalogics_shipping_map_street) {

                $address1 = $meta['value'];

            }

            if ($datalogics_shipping_map_house!='' && 
                    $datalogics_shipping_map_house!='address_2' && 
                        $meta['key']==$datalogics_shipping_map_house) {

                $address2 = $meta['value'];

            }

            if ($datalogics_shipping_map_apartment!='' && 
                        $meta['key']==$datalogics_shipping_map_apartment) {

                $apartment = $meta['value'];

            }

            if ($datalogics_shipping_map_entrance!='' && 
                        $meta['key']==$datalogics_shipping_map_entrance) {

                $entrance = $meta['value'];

            }

            if ($datalogics_shipping_map_floor!='' && 
                        $meta['key']==$datalogics_shipping_map_floor) {

                $floor = $meta['value'];

            }
            if ($datalogics_shipping_map_door!='' && 
                        $meta['key']==$datalogics_shipping_map_door) {

                $door = $meta['value'];

            }

        }

        

    } else {

        $address1 = $order['billing']['address_1'];
        $address2 = $order['billing']['address_2'];
        $city     = $order['billing']['city'];
        $company  = $order['billing']['company'];
        $phone    = $order['billing']['phone'];
        $fullname = $order['billing']['first_name'] . ' ' .$order['billing']['last_name']; 
        $apartment= '';
        $entrance = '';
        $floor = '';
        $door = '';
        

        $datalogics_billing_map_street      = get_option('datalogics_billing_map_street', '');
        $datalogics_billing_map_house       = get_option('datalogics_billing_map_house', '');
        $datalogics_billing_map_apartment   = get_option('datalogics_billing_map_apartment', '');
        $datalogics_billing_map_entrance    = get_option('datalogics_billing_map_entrance', '');
        $datalogics_billing_map_floor       = get_option('datalogics_billing_map_floor', '');
        $datalogics_billing_map_door        = get_option('datalogics_billing_map_door', '');

        if ($datalogics_billing_map_apartment=='address_1')
        {
            $apartment = $address1;
        }
        if ($datalogics_billing_map_apartment=='address_2')
        {
            $apartment = $address2;
        }
        if ($datalogics_billing_map_entrance=='address_1')
        {
            $entrance = $address1;
        }
        if ($datalogics_billing_map_entrance=='address_2')
        {
            $entrance = $address2;
        }
        if ($datalogics_billing_map_floor=='address_1')
        {
            $floor = $address1;
        }
        if ($datalogics_billing_map_floor=='address_2')
        {
            $floor = $address2;
        }
        
        foreach($order['meta_data'] as $meta) 
        {     
            
            $meta = (array)$meta;           
            $meta = end($meta);

            if ($datalogics_billing_map_street!='' && 
                    $datalogics_billing_map_street!='address_1' && 
                        $meta['key']==$datalogics_billing_map_street) {

                $address1 = $meta['value'];

            }

            if ($datalogics_billing_map_house!='' && 
                    $datalogics_billing_map_house!='address_2' && 
                        $meta['key']==$datalogics_billing_map_house) {

                $address2 = $meta['value'];

            }

            if ($datalogics_billing_map_apartment!='' && 
                        $meta['key']==$datalogics_billing_map_apartment) {

                $apartment = $meta['value'];

            }

            if ($datalogics_billing_map_entrance!='' && 
                        $meta['key']==$datalogics_billing_map_entrance) {

                $entrance = $meta['value'];

            }
            if ($datalogics_billing_map_floor!='' && 
                        $meta['key']==$datalogics_billing_map_floor) {

                $floor = $meta['value'];

            }
            if ($datalogics_billing_map_door!='' && 
                        $meta['key']==$datalogics_billing_map_door) {

                $door = $meta['value'];

            }

        }

    }

    return [
        'email' => $email,
        'address1'=>$address1,
        'address2'=>$address2,
        'city'=>$city,
        'phone'=>$phone,
        'fullname'=>$fullname,
        'apartment'=>$apartment,
        'entrance'=>$entrance,
        'company'=>$company,
        'floor' => $floor,
        'door'=>$door

    ];

}


function datalogics_get_cities_and_streets_data($json=false) {
    $data = array();
    $counter = 0;

    if (($handle = fopen(plugin_dir_path(__FILE__) . 'includes/list2.csv', 'r')) !== false) {

        while (($row = fgetcsv($handle, 1000, "\t")) !== false) {
            $counter++;
            if ($counter==1) {
                continue;
            }
            
            if (!isset($row[0]) && !isset($row[1])) {
                continue;
            }
            if (isset($row[0]) && $row[0]!='') {
                $row[0] = trim(iconv('Windows-1255', 'UTF-8', $row[0]));
            }
            if (isset($row[1]) && $row[1]!='') {
                $row[1] = trim(iconv('Windows-1255', 'UTF-8', $row[1]));
            }

            // var_dump($row); die;

            $pattern1 = array("(",")");
            $pattern2 = array("","");

            $row[0] = str_replace($pattern1,$pattern2,$row[0]);
            $row[1] = str_replace($pattern1,$pattern2,$row[1]);

            $row[0] = trim($row[0]);
            $row[1] = trim($row[1]);
            
            $data[] = array(
                'city' => $row[0],
                'street' => $row[1]
            );
        }
        fclose($handle);
    }
    
    // Use usort to sort the data array by 'city'
    usort($data, 'compareByCity');

    if ($json==true) {
        $data = json_encode($data);
    }
    
    return $data;
}

function compareByCity($a, $b) {
    return strcmp($a['city'], $b['city']);
}


add_action('wp_ajax_datalogics_city_lookup', 'datalogics_city_lookup');
add_action('wp_ajax_nopriv_datalogics_city_lookup', 'datalogics_city_lookup'); // For non-logged-in users

add_action('wp_ajax_datalogics_street_lookup', 'datalogics_street_lookup');
add_action('wp_ajax_nopriv_datalogics_street_lookup', 'datalogics_street_lookup'); // For non-logged-in users


function datalogics_city_lookup() {
    $search = isset($_POST['search']) ? sanitize_text_field($_POST['search']) : '';

    $cities = datalogics_get_matching_cities($search);
    wp_send_json($cities);
}


function datalogics_street_lookup() {
    $city = isset($_POST['city']) ? sanitize_text_field($_POST['city']) : '';
    $search = isset($_POST['search']) ? sanitize_text_field($_POST['search']) : '';
    $streets = datalogics_get_matching_streets($city, $search);
    wp_send_json($streets);
}



function datalogics_get_matching_cities($search) {

    $list = datalogics_get_cities_and_streets_data();

    $matching_cities = array();

    foreach ($list as $item) {

        if (stripos($item['city'], $search) !== false && !in_array($item['city'],$matching_cities)) {
            $matching_cities[] = $item['city'];
        }
    }


    return $matching_cities;
}


function datalogics_get_matching_streets($city, $search) {

    $list = datalogics_get_cities_and_streets_data();

    $matching_streets = array();

    foreach ($list as $item) {
        if (strcasecmp($item['city'], $city) === 0 && stripos($item['street'], $search) !== false && !in_array($item['street'],$matching_streets)) {
            $matching_streets[] = $item['street'];
        }
    }

    if (empty($matching_streets)) {
        $matching_streets[] = 'ללא רחוב';
    }

    return $matching_streets;
}



function datalogics_handle_file_upload() {
    check_admin_referer('datalogics_upload_image_nonce', 'nonce');

    if (!empty($_FILES['file'])) {
        $file = $_FILES['file'];

        $upload_dir = wp_upload_dir();        
        $target_dir = $upload_dir['path'];
        
        $target_file = $target_dir . '/' . basename($file['name']);

        
        if (move_uploaded_file($file['tmp_name'], $target_file)) {
            
            $upload_url = $upload_dir['url'] . '/' . basename($file['name']);
            wp_send_json_success(array('url' => $upload_url));
        } else {
            wp_send_json_error(array('message' => 'Error moving uploaded file.'));
        }
    } else {
        wp_send_json_error(array('message' => 'No file uploaded.'));
    }
}
add_action('wp_ajax_datalogics_handle_file_upload', 'datalogics_handle_file_upload');
//add_action('wp_ajax_nopriv_dreamax_term_handle_file_upload', 'dreamax_term_handle_file_upload');
