jQuery( function($) {

    // wc_city_select_params is required to continue, ensure the object exists
    // wc_country_select_params is used for select2 texts. This one is added by WC
    if ( typeof wc_country_select_params === 'undefined' || typeof wc_city_select_params === 'undefined' ) {
        return false;
    }

    var cities = JSON.parse(wc_city_select_params.cities);
    cities = cities['IL'];

    console.log(cities);

    var streets = JSON.parse(wc_city_select_params.streets);
    
    streets = streets['IL'];

    var AutoCompleteDatalogicsHTML = '<div class="datalogics-autocomplete" id="datalogics-autocomplete-city">';
    for(var i=0; i< cities.length; i++) {
        AutoCompleteDatalogicsHTML += '<div>'+cities[i]+'</div>'
    }
    AutoCompleteDatalogicsHTML += '</div>';


    var BillingCity = $("#billing_city_field");
    BillingCity.append(AutoCompleteDatalogicsHTML);

    var ShippingCity = $("#shipping_city_field");
    ShippingCity.append(AutoCompleteDatalogicsHTML);

    var datalogics_autocomplete_city_billing = BillingCity.find("#datalogics-autocomplete-city");
    var datalogics_autocomplete_city_shipping = ShippingCity.find("#datalogics-autocomplete-city");

    datalogics_autocomplete_city_billing.children("div").on("click",function(){

        $("#billing_city").val($(this).text());
        datalogics_autocomplete_city_billing.hide();


    })

    datalogics_autocomplete_city_shipping.children("div").on("click",function(){

        $("#shipping_city").val($(this).text());
        datalogics_autocomplete_city_shipping.hide();


    })

    $("#billing_city").on('input', function(e) {

        var text = $(this).val();

        datalogics_autocomplete_city_billing.children("div:not(:contains('" + text + "'))").removeClass("show");
        datalogics_autocomplete_city_billing.children("div:contains('" + text + "')").addClass("show");
        datalogics_autocomplete_city_billing.show();

    });


    $("#shipping_city").on('input', function(e) {

        var text = $(this).val();

        datalogics_autocomplete_city_shipping.children("div:not(:contains('" + text + "'))").removeClass("show");
        datalogics_autocomplete_city_shipping.children("div:contains('" + text + "')").addClass("show");
        datalogics_autocomplete_city_shipping.show();

    });

    var AutoCompleteDatalogicsHTML = '<div class="datalogics-autocomplete" id="datalogics-autocomplete-streets">';
    var BillingAddress = $("#billing_address_1_field");
    BillingAddress.append(AutoCompleteDatalogicsHTML);

    var ShippingAddress = $("#shipping_address_1_field");
    ShippingAddress.append(AutoCompleteDatalogicsHTML);

    var datalogics_autocomplete_streets_billing = BillingAddress.find("#datalogics-autocomplete-streets");
    var datalogics_autocomplete_streets_shipping = ShippingAddress.find("#datalogics-autocomplete-streets");

    $("#billing_address_1").on('input', function(e) {

        var city = $("#billing_city").val();

        var text = $(this).val();


        if (streets[city]) {

            var HTML = [];

            for(var i=0; i < streets[city].length; i++) {

                HTML.push('<div>'+streets[city][i]+'</div>');

            }

            datalogics_autocomplete_streets_billing.html(HTML.join(""));

            datalogics_autocomplete_streets_billing.children("div").on("click", function () {

                $("#billing_address_1").val($(this).text());
                datalogics_autocomplete_streets_billing.hide();

            })

            datalogics_autocomplete_streets_billing.children("div:not(:contains('" + text + "'))").removeClass("show");
            datalogics_autocomplete_streets_billing.children("div:contains('" + text + "')").addClass("show");
            datalogics_autocomplete_streets_billing.show();

        } else {

            console.log('didnf find');

        }

    });



    $("#shipping_address_1").on('input', function(e) {

        var city = $("#shipping_city").val();

        var text = $(this).val();


        if (streets[city]) {

            var HTML = [];

            for(var i=0; i < streets[city].length; i++) {

                HTML.push('<div>'+streets[city][i]+'</div>');

            }

            datalogics_autocomplete_streets_shipping.html(HTML.join(""));

            datalogics_autocomplete_streets_shipping.children("div").on("click", function () {

                $("#shipping_address_1").val($(this).text());
                datalogics_autocomplete_streets_shipping.hide();

            })

            datalogics_autocomplete_streets_shipping.children("div:not(:contains('" + text + "'))").removeClass("show");
            datalogics_autocomplete_streets_shipping.children("div:contains('" + text + "')").addClass("show");
            datalogics_autocomplete_streets_shipping.show();

        } else {

            console.log('didnf find');

        }

    });


    $("#billing_address_1_field").on("click",function() {

        $("#billing_city_field").find("#datalogics-autocomplete-city").hide();

    });
    $("#billing_city_field").on("click",function() {

        $("#billing_address_1_field").find("#datalogics-autocomplete-streets").hide();

    });

    $("#shipping_address_1_field").on("click",function() {

        $("#shipping_city_field").find("#datalogics-autocomplete-city").hide();

    });
    $("#shipping_city_field").on("click",function() {

        $("#shipping_address_1_field").find("#datalogics-autocomplete-streets").hide();

    });








});