String.prototype.addSlashes = function()
{
    //no need to do (str+'') anymore because 'this' can only be a string
    return this.replace(/[\\"']/g, '\\$&').replace(/\u0000/g, '\\0');
}


var mymap;
var myIcon;
var mymarker;

jQuery(document).ready(function($) {

    $(".datalogics_pickup_checkout_mid_list_close_buttons_close").on("click",function(){

        if ($(".datalogics_pickup_checkout_mid_list_close_buttons").hasClass("datalogics_pickup_checkout_mid_list_slide")) {
            $(".datalogics_pickup_checkout_mid_list_close_buttons,.datalogics_pickup_checkout_mid_notice,.datalogics_pickup_checkout_mid_list")
                .removeClass("datalogics_pickup_checkout_mid_list_slide")
        } else {

            $(".datalogics_pickup_checkout_mid_list_close_buttons,.datalogics_pickup_checkout_mid_notice,.datalogics_pickup_checkout_mid_list")
                .addClass("datalogics_pickup_checkout_mid_list_slide")
        }

    })

    if (object_data.datalogics_cities_auto) {

        $(document).on("focus","#billing_city,#shipping_city",function(e) {
            if ( !$(this).data("autocomplete") ) { // If the autocomplete wasn't called yet:

                var city_input = $(e.currentTarget);
                if (object_data.datalogics_cities_auto_validation) {
                    city_input.addClass('datalogics-shipping-input-error');
                }

                let autocompleteOpen = true;

                $('#billing_city,#shipping_city').autocomplete({
                    source: function (request, response) {                        

                        // Make an AJAX request to the server to look up cities
                        $.ajax({
                            url: object_data.ajax_url, // 'ajaxurl' is a global WordPress variable that points to the AJAX endpoint
                            type: 'POST',
                            dataType: 'json',
                            data: {
                                action: 'datalogics_city_lookup',
                                search: request.term
                            },
                            success: function (data) {
                                response(data);
                            },
                            error: function () {
                                response([]); // Return an empty array in case of an error
                            }
                        });
                    },
                    minLength: 1, // Minimum characters to start showing suggestions
                    delay: 300,    // Delay before fetching suggestions in milliseconds
                    select: function (event, ui) {
                        // This function will be called when a user selects an option
                        city_input.removeClass('datalogics-shipping-input-error');
                    },
                    classes: {
                        "ui-autocomplete": "datalogics-autocomplete", // Custom class for the autocomplete container
                        "ui-autocomplete-item": "datalogics-autocomplete-item", // Custom class for autocomplete items
                        "ui-state-active": "datalogics-autocomplete-item.ui-state-active", // Custom class for the selected item
                        "ui-autocomplete-input": "datalogics-autocomplete-input" // Custom class for the autocomplete input
                    },
                    open: function () {
                        autocompleteOpen = true;
                    },
                    close: function () {
                        autocompleteOpen = false;
                    },
                });

            }
        });

        $(document).on("focus","#billing_address_1",function(e) {
            if ( !$(this).data("autocomplete") ) { // If the autocomplete wasn't called yet:

                var address_input = $('#billing_address_1');
                if (object_data.datalogics_cities_auto_validation) {
                    address_input.addClass('datalogics-shipping-input-error');
                }

                let autocompleteOpen = true;

                // Initialize the autocomplete on the streets input based on the selected city
                $('#billing_address_1').autocomplete({
                    source: function (request, response) {
                        var city_input = $('#billing_city');
                        var selectedCity = city_input.val();

                        

                        // Make an AJAX request to the server to look up streets based on the selected city
                        $.ajax({
                            url: object_data.ajax_url,
                            type: 'POST',
                            dataType: 'json',
                            data: {
                                action: 'datalogics_street_lookup',
                                city: selectedCity,
                                search: request.term
                            },
                            success: function (data) {
                                console.log(data)
                                response(data);
                            },
                            error: function () {
                                response([]); // Return an empty array in case of an error
                            }
                        });
                    },
                    minLength: 1, // Minimum characters to start showing suggestions
                    delay: 300,    // Delay before fetching suggestions in milliseconds
                    select: function (event, ui) {
                        // This function will be called when a user selects an option
                        address_input.removeClass('datalogics-shipping-input-error');
                    },
                    classes: {
                        "ui-autocomplete": "datalogics-autocomplete", // Custom class for the autocomplete container
                        "ui-autocomplete-item": "datalogics-autocomplete-item", // Custom class for autocomplete items
                        "ui-state-active": "datalogics-autocomplete-item.ui-state-active", // Custom class for the selected item
                        "ui-autocomplete-input": "datalogics-autocomplete-input" // Custom class for the autocomplete input
                    },
                    open: function () {
                        autocompleteOpen = true;
                    },
                    close: function () {
                        autocompleteOpen = false;
                    },
                });

            }
        });


        $(document).on("focus","#shipping_address_1",function(e) {
            if ( !$(this).data("autocomplete") ) { // If the autocomplete wasn't called yet:

                var address_input = $('#shipping_address_1');
                if (object_data.datalogics_cities_auto_validation) {
                    address_input.addClass('datalogics-shipping-input-error');
                }

                let autocompleteOpen = true;

                $('#shipping_address_1').autocomplete({
                    source: function (request, response) {
                        var selectedCity = $('#shipping_city').val();

                        // Make an AJAX request to the server to look up streets based on the selected city
                        $.ajax({
                            url: object_data.ajax_url,
                            type: 'POST',
                            dataType: 'json',
                            data: {
                                action: 'datalogics_street_lookup',
                                city: selectedCity,
                                search: request.term
                            },
                            success: function (data) {
                                response(data);
                            },
                            error: function () {
                                response([]); // Return an empty array in case of an error
                            }
                        });
                    },
                    minLength: 1, // Minimum characters to start showing suggestions
                    delay: 300,    // Delay before fetching suggestions in milliseconds
                    select: function (event, ui) {
                        // This function will be called when a user selects an option
                        address_input.removeClass('datalogics-shipping-input-error');
                    },
                    classes: {
                        "ui-autocomplete": "datalogics-autocomplete", // Custom class for the autocomplete container
                        "ui-autocomplete-item": "datalogics-autocomplete-item", // Custom class for autocomplete items
                        "ui-state-active": "datalogics-autocomplete-item.ui-state-active", // Custom class for the selected item
                        "ui-autocomplete-input": "datalogics-autocomplete-input" // Custom class for the autocomplete input
                    },
                    open: function () {
                        autocompleteOpen = true;
                    },
                    close: function () {
                        autocompleteOpen = false;
                    },
                });

            }
        });

    }


    
    if (object_data.datalogics_ncode_auto) {  

        $(document).on("focus","#datalogics_n_code_city_select",function(e) {
            if ( !$(this).data("autocomplete") ) { // If the autocomplete wasn't called yet:
                $("#datalogics_n_code_city_select").autocomplete({
                    source: datalogics_ncode_list,
                    select: function (event, ui) {

                        let city = ui.item.value;
                        let nlist_el = $("#datalogics_n_code_select");

                        nlist_el.find(":not([data-city='"+city+"'])").hide(0);
                        nlist_el.find("[data-city='"+city+"']").show(0);

                        let firstSelect = nlist_el.find("[data-city='"+city+"']").eq(0);

                        firstSelect.prop("selected",true);        
                        

                        $("#datalogics_n_code_platform_id").val(firstSelect.data('platform-id'))  
                    }
                    
                });
            }
        });

    } else {

        $(document).on("change","#datalogics_n_code_city_select",function(){

            let el = $(this).find("option:selected");
            let city = el.data('city');
            let nlist_el = $("#datalogics_n_code_select");

            nlist_el.find(":not([data-city='"+city+"'])").hide(0);
            nlist_el.find("[data-city='"+city+"']").show(0);

            let firstSelect = nlist_el.find("[data-city='"+city+"']").eq(0);

            firstSelect.prop("selected",true);         
            

            $("#datalogics_n_code_platform_id").val(firstSelect.data('platform-id'))  
        

        })

    }

    $(document).on("change","#datalogics_n_code_select",function(){

        let el = $(this).find("option:selected");
        let platform_id = el.data('platform-id');

        $("#datalogics_n_code_platform_id").val(platform_id)        

    })

    

    if (typeof google !== 'undefined') {


        google.maps.event.addDomListener(window, 'load', initialize);

        function initialize() {
            var input = document.getElementById('datalogics-location-input');
            var autocomplete = new google.maps.places.Autocomplete(input);

            google.maps.event.addListener(autocomplete, 'place_changed', function() {
                $(".datalogics_pickup_locate_button").click();
            });

        }

    }




    var click_count = 0;
    //Check if ajax ran is update_order_review
    //jQuery(document).ajaxComplete(function(event,request, settings){
        //if(settings.url.includes('update_order_review')){

            /*

            jQuery('#ship-to-different-address-checkbox').prop( "disabled", false); 
            //Check/Uncheck shipping address checkbox based on if form is hidden/displayed
            if(jQuery('.shipping_address').css('display') == 'none') {
                jQuery('#ship-to-different-address-checkbox').prop("checked", false);
            } else {
                jQuery('#ship-to-different-address-checkbox').prop("checked", true);
            }

            */




            $(document).on("click",".datalogics_pickup_checkout_top2_button",function () {

                var action = $(this).data("action");
                if (action=='map') {
                    $(".datalogics_pickup_checkout_mid_list").hide();
                    $(".datalogics_pickup_checkout_mid_map").show();
                } else {
                    $(".datalogics_pickup_checkout_mid_list").show();
                    $(".datalogics_pickup_checkout_mid_map").hide();
                }

            })




            $(document).on("click",".datalogics-choose-location",function(){


                let searchInput = $('#datalogics-location-input');

                if (searchInput.val()=='') {

                    let billing_city = $("#billing_city").val();
                    let billing_address_1 = $("#billing_address_1_field").val();
                    let shipping_city = $("#shipping_city").val();
                    let shipping_address_1 = $("#shipping_address_1_field").val();    
                    let string_value = '';                

                    if (shipping_city!==undefined && shipping_city!='') {
                        string_value += shipping_city;
                        if (shipping_address_1!==undefined && shipping_address_1!='') {
                            string_value += ' ' + shipping_address_1;
                        }

                    } else if (billing_city!==undefined && billing_city!=''){
                        string_value += billing_city
                        if (billing_address_1!==undefined && billing_address_1!='') {
                            string_value += ' ' + billing_address_1;
                        }
                    }

                    if (string_value.trim()!='') {
                        searchInput.val(string_value.trim())     
                    }

                    $(".datalogics_pickup_locate_button").click();

                }

                

                $(".datalogics_pickup_checkout").css("display","flex");
                loadMap();

            })


            // Execute a function when the user releases a key on the keyboard
            $(document).on("keyup",".datalogics_pickup_checkout_input input", function(event) {
                // Number 13 is the "Enter" key on the keyboard
                if (event.keyCode === 13) {
                    // Cancel the default action, if needed
                    $(this).siblings("button").click();
                }
            });




            $(document).on("click",".datalogics_pickup_locate_button",function () {

                var address = $(this).siblings("input").val();

                var geocoder;

                if (object_data.datalogics_google_key!='') {

                    geocoder =  new google.maps.Geocoder();

                }

            

                if (geocoder) {

                    geocoder.geocode( { 'address': address}, function(results, status) {

                        if (results!==null && results.length>0) {

                            var location = results[0].geometry.location;
                            //alert(location.lat() + '' + location.lng());

                            if (!mymarker) {

                                var myIcon = L.divIcon({className: 'map-icon-new-my', iconSize: [50,50]});

                                mymarker = L.marker([location.lat(), location.lng()], {icon: myIcon, draggable: 'true'});

                                mymarker.on('dragend', function(event){
                                    var marker = event.target;
                                    var position = marker.getLatLng();
                                    marker.setLatLng(new L.LatLng(position.lat, position.lng),{draggable:'true'});
                                    mymap.panTo(new L.LatLng(position.lat, position.lng))

                                    getLocationByPosition(position.lat, position.lng)

                                });

                                //var marker = L.marker([location.lat(),location.lng()],{icon: myIcon}).addTo(mymap);
                                mymap.addLayer(mymarker)

                            }

                            mymarker.setLatLng(new L.LatLng(location.lat(),location.lng()),{draggable:'true'});
                            mymap.setView([location.lat(), location.lng()], 13);

                            getLocationByPosition(location.lat(), location.lng())

                        }


                    });

                } else {

                    $(".datalogics_pickup_checkout_mid_list_row:not(:contains('"+address+"'))").hide(0);
                    $(".datalogics_pickup_checkout_mid_list_row:contains('"+address+"')").show(0);
                    
                    
                }


            })


        //} 
    //});
    //If datalogics method is selected on load empty the shipping values
    /*
    if(typeof(jQuery('#datalogics_pickup_cities').html()) != 'undefined'){
        jQuery('#shipping_first_name').val('');
        jQuery('#shipping_last_name').val('');
        jQuery('#shipping_address_1').val('');
        jQuery('#shipping_city').val('');
        jQuery('#shipping_postcode').val('');
        jQuery('#shipping_company').val('');
    }
    */
    
    //Action if we select location from list
    jQuery(document).on('change', '#datalogics_pickup_locations', function() {


        if(jQuery(this).val() != null){
            //Fill shipping details
            //Get value from selected radio input
            var value = JSON.parse(jQuery('input[name=datalogics_pickup_locations]:checked').val().replace(/'/g, '"'));
            var dshipping = jQuery('#ship-to-different-address-checkbox');

            /*
            if (dshipping.prop( "checked")==false) {

                jQuery('#ship-to-different-address-checkbox').click();
            }
            jQuery('#shipping_first_name').val(value['name']);
            if (jQuery('#shipping_address_2').length==0) {
                jQuery('#shipping_address_1').val(value['street'] + ' ' + value['house']);
            } else {
                jQuery('#shipping_address_1').val(value['street']);
                jQuery('#shipping_address_2').val(value['house']);
            }
            jQuery('#shipping_city').val(value['city']);
            jQuery('#shipping_postcode').val(jQuery('#billing_postcode').val());
            jQuery('#shipping_country').val(jQuery('#billing_country').val());
            */
            jQuery('#datalogics_n_code').val(value['n_code']);
            var message = value['name'] + ', '+ value['street'] + ' ' + value['house'] + ', ' + value['city'];
            jQuery('#datalogics_pickup_cities_message').html('נקודת החלוקה שנבחרה היא: ' + message);

            /*jQuery(".shipping_address input").each(function(){
                var el = jQuery(this);
                if (el.val()=='') {
                    if(el.attr('id') == 'shipping_postcode')
                        el.val('00000');
                    else
                        el.val('-');
                }
            });
            */
            click_count++;
        }    
    });






    function loadMap(){

        console.log('map load');

        var container = L.DomUtil.get('datalogics-map');
        if(container != null){
            container._leaflet_id = null;
        }

        //Empty our n_code value
        jQuery('#datalogics_n_code').val('');
        jQuery('#datalogics_n_code_platform_id').val('');
        jQuery('#datalogics_pickup_cities_message').html('');

        //Show map <div> and fill it with map, we center it on first location in array of locations

        var vendor = '';
        if (object_data.shipping_push_supplier) {
            vendor = object_data.shipping_push_supplier;
        }
        var mapIcon = L.divIcon({className: 'map-icon-new map-icon-new' + vendor, iconSize: [40,40]});

        if (!mymap) {

            var lat = '32.085300';
            var long = '34.781769'
            mymap = L.map('datalogics-map',{zoomControl: false}).setView([lat, long], 16);

            L.control.zoom({
                position: 'bottomright'
            }).addTo(mymap);

            //console.log(object_data);

            myIcon = L.divIcon({className: 'map-icon-new-my', iconSize: [50,50]});


            L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
                attribution: '&copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors',
                maxZoom: 18,
                // id: 'mapbox/streets-v11',
                // tileSize: 512,
                // zoomOffset: -1,
                // locale : "he",
            }).addTo(mymap);

            mymap.locate({setView: true}).on('locationfound', function (e) {

                if (!mymarker) {
                    mymarker = L.marker([e.latitude, e.longitude], {icon: myIcon, draggable: 'true'});
                    mymap.panTo(new L.LatLng(e.latitude, e.longitude))
                    mymap.addLayer(mymarker)
                    mymap.setView([e.latitude, e.longitude], 16);

                    getLocationByPosition(e.latitude, e.longitude)

                    mymarker.on('dragend', function (event) {
                        var marker = event.target;
                        var position = marker.getLatLng();
                        marker.setLatLng(new L.LatLng(position.lat, position.lng), {draggable: 'true'});
                        mymap.panTo(new L.LatLng(position.lat, position.lng))

                        getLocationByPosition(position.lat, position.lng)

                    });

                }

            });

        }

        $.ajax(object_data.ajax_url, {
            type: 'POST',  // http method
            data: {
                action: 'datalogics_get_locations'
            },  // data to submit
            success: function (data, status, xhr) {



                var locations_by_platform = data;
                if (locations_by_platform) {

                    for(var platform_id in locations_by_platform) {

                        var cities = locations_by_platform[platform_id];

                        if (cities) {

                            var markers = L.markerClusterGroup();


                            for(var locations in cities) {

                                var locations_data = cities[locations];

                                //Create marker for each location for that city, we show values, we can change what is shown
                                locations_data.forEach(function (value, index) {

                                    //console.log(value);

                                    if (!value || typeof value['latitude'] !== 'string'  ) {
                                        return;
                                    }

                                    //console.log(Array.isArray(value['remarks']))

                                    if (value['remarks']=='' || value['remarks']=='Array' || Array.isArray(value['remarks'])) {

                                        value['remarks'] = ''

                                    } else {

                                        value['remarks'] += '<br>';

                                    }

                                    //console.log(value['name'] + ' ' + value['latitude'] + ' ' +  value['longitude']);


                                    //locations_data[index] = value;
                                    var marker = L.marker([value['latitude'], value['longitude']],{icon: mapIcon});
                                    //var marker = L.marker([value['latitude'], value['longitude']]).addTo(mymap);
                                    marker.bindPopup('<b>' + value['name'] + '</b><br>' + '<b>' + value['city'] + '</b><br>' + value['street'] + ' ' + value['house'] +'<br>'+value['remarks']+'<span class="datalogics-map-select-button" onclick="selectLocation(\'' + value['name'] +'\',\''+value['street']+'\',\''+value['house']+'\',\''+value['city']+'\',\''+value['n_code']+'\',\''+platform_id+'\'); closeMap();">בחר נקודה</span>');
                                    marker.on('click', function (ev) {
                                        //Fill shipping details
                                        //jQuery('#ship-to-different-address-checkbox').prop( "checked", true );
                                        //jQuery('#ship-to-different-address-checkbox').prop( "disabled", true );

                                        //selectLocation(value['name'],value['street'],value['house'],value['city'],value['n_code'])

                                        // var dshipping = jQuery('#ship-to-different-address-checkbox');
                                        // if (dshipping.prop("checked") == false) {
                                        //
                                        //     jQuery('#ship-to-different-address-checkbox').click();
                                        // }
                                        // jQuery('#shipping_first_name').val(value['name']);
                                        // if (jQuery('#shipping_address_2').length == 0) {
                                        //     jQuery('#shipping_address_1').val(value['street'] + ' ' + value['house']);
                                        // } else {
                                        //     jQuery('#shipping_address_1').val(value['street']);
                                        //     jQuery('#shipping_address_2').val(value['house']);
                                        // }
                                        // jQuery('#shipping_city').val(value['city']);
                                        // jQuery('#shipping_postcode').val(jQuery('#billing_postcode').val());
                                        // jQuery('#shipping_country').val(jQuery('#billing_country').val());
                                        // jQuery('#datalogics_n_code').val(value['n_code']);
                                        // var message = value['name'] + ', ' + value['street'] + ' ' + value['house'] + ', ' + value['city'];
                                        // jQuery('#datalogics_pickup_cities_message').html('איסוף עצמי מנקודת חלוקה' + message);
                                        //
                                        // jQuery(".shipping_address input").each(function () {
                                        //     var el = jQuery(this);
                                        //     if (el.val() == '') {
                                        //         if (el.attr('id') == 'shipping_postcode')
                                        //             el.val('00000');
                                        //         else
                                        //             el.val('-');
                                        //     }
                                        // });

                                        click_count++;
                                    });

                                    
                                    if (markers) {
                                        markers.addLayer(marker);
                                    }


                                });

                                if (mymap) {

                                    mymap.addLayer(markers);

                                }



                            }

                        }

                    }
                }
            }
        });

    }

    jQuery(document).on("click",".datalogics_pickup_checkout_close",function () {

        jQuery(".datalogics_pickup_checkout").hide();

    })





    function getLocationByPosition(lat,long) {

        $.ajax(object_data.ajax_url, {
            type: 'POST',  // http method
            data: { action: 'datalogics_get_close_locations', lat: lat, long : long  },  // data to submit
            success: function (data, status, xhr) {

                $(".datalogics_pickup_checkout_mid_list").html(data)

            },
            error: function (jqXhr, textStatus, errorMessage) {
                console.log(textStatus);
            }
        });

    }




});

function setLocation(lat,long) {

    if (mymap) {

        mymap.setView([lat, long], 16);

    }

}


function closeMap(){
    jQuery(".datalogics_pickup_checkout").hide();
}



function selectLocation(name,street,house,city,n_code,platform_id) {


    var list = jQuery(".datalogics_pickup_checkout_mid_list")


    //console.log(".datalogics_pickup_checkout_mid_list_row[data-ncode='"+n_code+"']")

    list.find(".datalogics_pickup_checkout_mid_list_row:not([data-ncode='"+n_code+"']):not([data-platform_id='"+platform_id+"'])").removeClass("selected")

    var el = list.find(".datalogics_pickup_checkout_mid_list_row[data-ncode='"+n_code+"'][data-platform_id='"+platform_id+"']");


    el.addClass("selected")

    // var pos = el[0].offsetTop - 200;
    //
    // list[0].scrollTop = pos

    var dshipping = jQuery('#ship-to-different-address-checkbox');
    /*
    if (dshipping.prop("checked") == false) {

        jQuery('#ship-to-different-address-checkbox').click();
    }
    jQuery('#shipping_first_name').val(name);
    if (jQuery('#shipping_address_2').length == 0) {
        jQuery('#shipping_address_1').val(street + ' ' + house);
    } else {
        jQuery('#shipping_address_1').val(street);
        jQuery('#shipping_address_2').val(house);
    }
    jQuery('#shipping_city').val(city);
    jQuery('#shipping_postcode').val(jQuery('#billing_postcode').val());
    jQuery('#shipping_country').val(jQuery('#billing_country').val());
    */
    jQuery('#datalogics_n_code').val(n_code);
    jQuery('#datalogics_n_code_platform_id').val(platform_id);
    var message = name + ', ' + street + ' ' + house + ', ' + city;
    jQuery('#datalogics_pickup_cities_message').html('איסוף עצמי מנקודת חלוקה: ' + message);

    /*
    jQuery(".shipping_address input").each(function () {
        var el = jQuery(this);
        if (el.val() == '') {
            if (el.attr('id') == 'shipping_postcode')
                el.val('00000');
            else
                el.val('-');
        }
    });
    */


    closeMap();


}
